<!--#INCLUDE FILE="xml.runtime6.asp"-->
<%init_cm_runtime6_js()%>
<SCRIPT runat="server" language="JScript">
	
// *****************************************************************************
//
// include/custommerchant.runtime6.asp
//
// GoLive runtime support for CustomMerchant
//
// ADOBE SYSTEMS INCORPORATED
// Copyright 1999-2002 Adobe Systems Incorporated. All Rights Reserved.
// 
// NOTICE:  Notwithstanding the terms of the Adobe GoLive End User 
// License Agreement, Adobe permits you to reproduce and distribute this 
// file only as an integrated part of a web site created with Adobe 
// GoLive software and only for the purpose of enabling your client to 
// display their web site. All other terms of the Adobe license 
// agreement remain in effect.
//

// *****************************************************************************
// HTTP AND XML UTILITIES

// -----------------------------------------------------------------------------
// Get the results of an HTTP query as a string.

function GetHTTPResultsAsText(providerURL, query)
{
	var http = new ActiveXObject("MSXML2.ServerXMLHTTP");
	http.open("GET", providerURL + "?" + query, false);

	// Disable all caching:
	http.setRequestHeader("if-modified-since", "Mon, 1 Jan 1900");

	http.send();

	if (http.status >= 300) {
		return "$error: " + http.status + "\r\n" + http.responseText;
	} else {
		return http.responseText;
	}
}

// -----------------------------------------------------------------------------
// Get the results of an HTTP query as a DOM tree.

function GetHTTPResults(providerURL, query)
{
	var http = new ActiveXObject("MSXML2.ServerXMLHTTP");
	http.open("GET", providerURL + "?" + query, false);

	// Disable all caching:
	http.setRequestHeader("if-modified-since", "Mon, 1 Jan 1900");

	http.send();

	return http.responseXML;
}


// *****************************************************************************
// CUSTOM MERCHANT UTILITIES

// -----------------------------------------------------------------------------
// Get the provider info from the e-commerce provider datasource.

function GetProviderInfo(provider)
{
	var providerInfo = new Object;

	var fileSystem = new ActiveXObject("Scripting.FileSystemObject");
	var filePath = GetDataSourcePath() + provider;

	if (fileSystem.FileExists(filePath + ".ecp")) {
		var ts = fileSystem.OpenTextFile(filePath + ".ecp", 1);	// forReading
		var lines = GL_FileFromTextStream(ts);
		ts.Close();
		for (var i = 0; i < lines.length; i++){ 
			var line = lines[i];
			if (line.match(/^\s*url\s*(.*)/)) {
				providerInfo.url = RegExp.$1;
			} else if (line.match(/^\s*merchant-id\s*(.*)/)) {
				providerInfo.merchantId = RegExp.$1;
			}
		}
	} else {
		providerInfo.url = "provider not found";
		providerInfo.merchantId = "-1";
	}

	return providerInfo;
}

// -----------------------------------------------------------------------------
// Return the current shopper-id from the session, or create a new one.

function GetShopperId(provider)
{
	var shopperId = Session("shopper-id");
	if (typeof(shopperId) == "undefined" || String(shopperId).length == 0) {
		var providerInfo = GetProviderInfo(provider);
		var query = "action=new-cart&merchant-id=" + providerInfo.merchantId;
		var dom = GetHTTPResults(providerInfo.url, query);
		shopperId = dom.text;
		Session("shopper-id") = shopperId;
	}
	return shopperId;
}


// *****************************************************************************
// CONTENT SOURCE WRAPPERS: CART AND ORDERFORM
//
// Items are accessed through the wrappers as follows:
//
//	  set cart = CustomMerchantCart("block=1", "ecommerce_provider", "cart")
//	  cart.MoveFirst
//	  cart.Value("description")
//
//	  set orderForm = CustomMerchantOrderForm("block=1",_
//		"ecommerce_provider", "orderForm")
//	  orderForm.Value("ship_to_name")
//	  orderForm.Value("cc-number")

function CustomMerchantCart(records, provider, name)
{
	var providerInfo = GetProviderInfo(provider);
	var shopperId = GetShopperId(provider);

	var cart = new CSWCart(providerInfo.url, providerInfo.merchantId, shopperId);
	cart.Name = name;

	/*
	 * This implementation doesn't support blocking.
	 * (The "records" parameter is ignored.)
	 */
	return cart;
}

function CustomMerchantOrderForm(records, provider, name)
{
	var providerInfo = GetProviderInfo(provider);
	var shopperId = GetShopperId(provider);

	var orderForm = new CSWOrderForm(providerInfo.url, providerInfo.merchantId, shopperId);
	orderForm.Name = name;

	//
	// This implementation doesn't support blocking.  Order forms contain only 
	// a single record.  (The "records" parameter is ignored.)
	//

	return orderForm;
}

// -----------------------------------------------------------------------------
// Content source wrapper for shopping cart.

function CSWCart(providerURL, merchantId, shopperId)
{
	// Method table:
	this.Move = CSWCart_Move;
	this.MoveFirst = CSWCart_MoveFirst;
	this.MoveNext = CSWCart_MoveNext;
	this.MoveTo = CSWCart_MoveTo;
	this.Value = CSWCart_Value;
	this.Error = CSWCart_Error;
	this.Key = CSWCart_Key;
	this.NestedCSW = CSWCart_NestedCSW;

	this.providerURL = providerURL;
	this.merchantId = merchantId;
	this.shopperId = shopperId;

	var args = new Array;
	args["action"] = "get-cart";
	args["merchant-id"] = merchantId;
	args["shopper-id"] = shopperId;
	var edoc = SafeLoad(providerURL+'?'+queryArrayToString(args));
	/*
	 * <custommerchant-result>
	 *	<shopping-cart>
	 * We want to select the (single) <shopping-cart>,
	 * so use 2 levels of *.
	 */
	var csx = new XMLSource(edoc.selectNodes('/*/*'));
	this.csx = csx;
	this.AbsolutePosition = 1;
	this.RecordCount = csx.RecordCount;
	this.FirstRecordOnPage = 1;
	this.LastRecordOnPage = this.RecordCount;
	this.BlockSize = this.RecordCount;
	this.EOB = false;
	this.EOF = false;

	this.MoveFirst();
}

// -------------------------------------------------------------------------
// Cursor positioning:

function CSWCart_Move(delta)
{
	this.MoveTo(this.AbsolutePosition + Number(delta));
}

function CSWCart_MoveFirst()
{
	this.MoveTo(1);
}

function CSWCart_MoveNext()
{
	this.Move(1);
}

function CSWCart_MoveTo(pos)
{
	csw_MoveTo(this.csx, pos);
	this.AbsolutePosition = this.csx.AbsolutePosition;
	csw_FixCursor(this);
}

function CSWCart_NestedCSW(field)
{
	return this.csx.NestedCSW(field);
}

// -------------------------------------------------------------------------
// Data access:

function CSWCart_Value(fieldName)
{
	return this.csx.Value(fieldName);
}

function CSWCart_Error(fieldName)
{
	return this.csx.Error(fieldName);
}

function CSWCart_Key()
{
	return this.Value("sku");
}

// -----------------------------------------------------------------------------
// Content source wrapper for order form.

function CSWOrderForm(providerURL, merchantId, shopperId)
{
	// Method table:
	this.Move = CSWOrderForm_Move;
	this.MoveFirst = CSWOrderForm_MoveFirst;
	this.MoveNext = CSWOrderForm_MoveNext;
	this.MoveTo = CSWOrderForm_MoveTo;
	this.NestedCSW = CSWOrderForm_NestedCSW;
	this.Value = CSWOrderForm_Value;
	this.Error = CSWOrderForm_Error;
	this.Key = CSW_NOP;

	this.providerURL = providerURL;
	this.merchantId = merchantId;
	this.shopperId = shopperId;

	var args = new Array;
	args["action"] = "get-order-form";
	args["merchant-id"] = merchantId;
	args["shopper-id"] = shopperId;
	var edoc = SafeLoad(providerURL+'?'+queryArrayToString(args));
	/*
	 * <custommerchant-result>
	 *	<order-form>
	 * We want to select the (single) <order-form>,
	 * so use 2 levels of *.
	 */
	var csx = new XMLSource(edoc.selectNodes('/*/*'));
	this.csx = csx;
	this.RecordCount = csx.RecordCount;

	this.AbsolutePosition = 1;
	this.RecordCount = this.csx.RecordCount;
	this.FirstRecordOnPage = 1;
	this.LastRecordOnPage = this.RecordCount;
	this.BlockSize = this.RecordCount;
	this.EOB = false;
	this.EOF = false;

	this.MoveFirst();
}

// -------------------------------------------------------------------------
// Cursor positioning:

function CSWOrderForm_Move(delta)
{
	this.MoveTo(this.AbsolutePosition + Number(delta));
}

function CSWOrderForm_MoveFirst()
{
	this.MoveTo(1);
}

function CSWOrderForm_MoveNext()
{
	this.Move(1);
}

function CSWOrderForm_MoveTo(pos)
{
	csw_MoveTo(this.csx, pos);
	this.AbsolutePosition = this.csx.AbsolutePosition;
	csw_FixCursor(this);
}

function CSWOrderForm_NestedCSW(field)
{
	return this.csx.NestedCSW(field);
}

// -------------------------------------------------------------------------
// Data access:

function CSWOrderForm_Value(fieldName)
{
	return this.csx.Value(fieldName);
}

function CSWOrderForm_Error(fieldName)
{
	return this.csx.Error(fieldName);
}


// *****************************************************************************
// ACTION SETUP ROUTINES

var setupArgs;
function init_cm_runtime6_js()
{
	setupArgs = new Array();
}

// -----------------------------------------------------------------------------

function MakeCMReturnURL(url)
{
	var thisPage = Request("URL");
	if (url == "$return") {
		return thisPage + "?" + Request.QueryString;
	} else {
		return absolutePath(thisPage, url);
	}
}

// -----------------------------------------------------------------------------

function SetupAddToCart(successLink, failureLink, provider, sku, description, unitPrice)
{
	setupArgs["add-to-cart_success"] = MakeCMReturnURL(successLink);
	setupArgs["add-to-cart_failure"] = MakeCMReturnURL(failureLink);
	setupArgs["provider"] = provider;
	setupArgs["sku"] = sku;
	setupArgs["description"] = description;
	setupArgs["unit-price"] = unitPrice;
}

// -----------------------------------------------------------------------------

function SetupUpdateTotals(successLink, failureLink, cart)
{
	setupArgs["change-cart-props_success"] = MakeCMReturnURL(successLink);
	setupArgs["change-cart-props_failure"] = MakeCMReturnURL(failureLink);

	var items = cart.NestedCSW("item");
	items.MoveFirst();
	while (!items.EOF) {
		var keyName = "key[" + items.AbsolutePosition + "]";
		setupArgs[keyName] = items.Value("sku");
		items.MoveNext();
	}
	items.MoveFirst();
}

// -----------------------------------------------------------------------------

function SetupClearCart(successLink, failureLink, cart)
{
	setupArgs["clear-cart_success"] = MakeCMReturnURL(successLink);
	setupArgs["clear-cart_failure"] = MakeCMReturnURL(failureLink);
}

// -----------------------------------------------------------------------------

function SetupUpdateOrder(successLink, failureLink, orderform)
{
	setupArgs["change-order-form-props_success"] = MakeCMReturnURL(successLink);
	setupArgs["change-order-form-props_failure"] = MakeCMReturnURL(failureLink);
}

// -----------------------------------------------------------------------------

function SetupPurchaseNow(successLink, failureLink, orderform)
{
	setupArgs["purchase_success"] = MakeCMReturnURL(successLink);
	setupArgs["purchase_failure"] = MakeCMReturnURL(failureLink);
}

// -----------------------------------------------------------------------------
// Setup the form.  This function must at least write out the setup arguments
// added by the individual action setup functions.

function SetupCustomMerchantForm(contentSource)
{
	//
	// Write out the standard info:
	//
	if (typeof(contentSource) == "object") {
		Response.Write("<input type='hidden' name='$provider-url' value='" + contentSource.providerURL + "'>");
		Response.Write("<input type='hidden' name='$merchant-id' value='" + contentSource.merchantId + "'>");
		Response.Write("<input type='hidden' name='$shopper-id' value='" + contentSource.shopperId + "'>");
	} else {
		var provider = setupArgs["provider"];
		var providerInfo = GetProviderInfo(provider);
		var shopperId = GetShopperId(provider);

		Response.Write("<input type='hidden' name='$provider-url' value='" + providerInfo.url + "'>");
		Response.Write("<input type='hidden' name='$merchant-id' value='" + providerInfo.merchantId + "'>");
		Response.Write("<input type='hidden' name='$shopper-id' value='" + shopperId + "'>");
	}

	//
	// Write out all the args collected from the SetupAction calls:
	//
	for (var key in setupArgs) {
		Response.Write("<input type='hidden' name='$" + key + "' value='" + setupArgs[key] + "'>");
	}
	setupArgs = [];
}

</SCRIPT>
