<SCRIPT runat="server" language="JScript">
// *****************************************************************************
//
// include/extrafilters.runtime6.asp
//
// GoLive extra filters for ASP.
//
// ADOBE SYSTEMS INCORPORATED
// Copyright 2001-2002 Adobe Systems Incorporated. All Rights Reserved.
// 
// NOTICE:  Notwithstanding the terms of the Adobe GoLive End User 
// License Agreement, Adobe permits you to reproduce and distribute this 
// file only as an integrated part of a web site created with Adobe 
// GoLive software and only for the purpose of enabling your client to 
// display their web site. All other terms of the Adobe license 
// agreement remain in effect.


//  Truncate string and add truncatedString 
//  when the length is longer than cutOffLength
function Truncate(source, cutOffLength, truncatedString)
{
	if ((typeof(truncatedString) == "undefined")||(String(source).length <= cutOffLength)) {
		return String(source).substring(0, cutOffLength);
	} else {
		return String(source).substring(0, cutOffLength) + truncatedString;
	}
}

//  Do RegExp.match
//	If it matched, it returns match string. 
//  If match string iclude $1-$9, it will be replaced.
//	If it was not matched, it returns notMatch string
function RegExpMatch(source, regExp, ignoreCase, match, notMatch)
{
	var match = String(match);
	var re = (ignoreCase ? new RegExp(regExp, "gi") : new RegExp(regExp, "g"));
	if (String(source).match(re) == null) {	// not matched
		return (notMatch == "" ? source : notMatch);
	} else {
		if (match == "") {
			return source;
		}
		if (match.indexOf("$") == -1) {
			return match;
		}
		
		var replaced = "";
		re.exec(String(source));
		for (var i = 0; i < match.length; i++) {
			if (match.charAt(i) != '$') {
				replaced += match.charAt(i);
			} else {	// with '$'
				i++;
				if (i >= match.length) {
					break;
				}
				switch(match.charAt(i)) {
					case '1':	replaced += RegExp.$1;			break;
					case '2':	replaced += RegExp.$2;			break;
					case '3':	replaced += RegExp.$3;			break;
					case '4':	replaced += RegExp.$4;			break;
					case '5':	replaced += RegExp.$5;			break;
					case '6':	replaced += RegExp.$6;			break;
					case '7':	replaced += RegExp.$7;			break;
					case '8':	replaced += RegExp.$8;			break;
					case '9':	replaced += RegExp.$9;			break;
					default:	replaced += match.charAt(i);	break;
				}
			}
		}
		return replaced;
	}
}

//  Do RegExp.replace
function RegExpReplace(source, regExp, ignoreCase, replace)
{
	var re = (ignoreCase ? new RegExp(regExp, "i") : new RegExp(regExp, ""));
	return String(source).replace(re, replace);
}

</SCRIPT>

