<%init_utils_runtime6_vbs()%>
<%init_utils_runtime6_js()%>

<SCRIPT runat="server" language="VBScript">
' *****************************************************************************
'
' include/utils.runtime6.asp
'
' GoLive utilities for ASP.
'
' ADOBE SYSTEMS INCORPORATED
' Copyright 1999-2002 Adobe Systems Incorporated. All Rights Reserved.
'
' NOTICE:  Notwithstanding the terms of the Adobe GoLive End User
' License Agreement, Adobe permits you to reproduce and distribute this
' file only as an integrated part of a web site created with Adobe
' GoLive software and only for the purpose of enabling your client to
' display their web site. All other terms of the Adobe license
' agreement remain in effect.

' -----------------------------------------------------------------------------
' Initialize VBScript part
function init_utils_runtime6_vbs()
	Response.Buffer = true
	Response.CharSet = "windows-" & Session.CodePage
end function


' -----------------------------------------------------------------------------
' VBScript style DateTime format conversion for calling from JScript
' return string type

function callVBFormatDateTime(dateField)
	if IsDate(dateField) then
		callVBFormatDateTime = FormatDateTime(dateField, 0)
	else
		callVBFormatDateTime = ""
	end if
end function


' -----------------------------------------------------------------------------
' Encode single/double quotation mark as HTML encode

function fixHTMLquotes(text)
	dim temp
	if IsNull(text) then
		fixHTMLquotes = ""
	else
		temp = Replace(text, """", "&#34;")
		fixHTMLquotes = Replace(temp, "'", "&#39;")
	end if
end function

' -----------------------------------------------------------------------------
' Return a URL query parameter with a given name.  If missing or null, return
' a defaultValue.  Called from user code.
function pageParameter(name, defaultValue)
	pageParameter = Request.QueryString(name)
	if pageParameter = "" then
		pageParameter = defaultValue
	end if
end function

</SCRIPT>

<SCRIPT runat="server" language="JScript">

// *****************************************************************************
// Global variables
var RuntimeDebug;	// DEBUGGING: true or false (default)
var FORMERR_NAME;

// *****************************************************************************
// Initialize JScript part
function init_utils_runtime6_js()
{
	RuntimeDebug = false;	// true or false (default)
	FORMERR_NAME = "FORMERR";
	return;
}

function RuntimeDebugMessage(msg)
{
	Response.Write("<b><font color=\"red\">Runtime Debug Message: " + msg + "</font></b><br>\n");
	return;
}

function debugPrintQueryString()
{
	var msg = "";
	msg += "Query String<br>\n";
	if (Request.QueryString.Count == 0){
		msg += "No data<br>\n";
	} else {
		msg += "Data count = " + Request.QueryString.Count + "<br>\n";
		msg += "<table border=\"1\">\n";
		msg += "<tr><th>parameter</th><th>count</th><th>array</th></tr>\n";
		for (var i = 1; i <= Request.QueryString.Count; i++) {
			var key   = Request.QueryString.Key(i);
			var value = Request.QueryString.Item(key);
			for (var j = 1; j <= value.Count; j++) {
				msg += "<tr><td>" + key + "</td><td>" + j + "</td><td>" + value.Item(j) + "</td></tr>\n";
			}
		}
		msg += "</table>\n";
	}
	RuntimeDebugMessage(msg);
}


function debugPrintFormData()
{
	var msg = "";
	msg += "Form Data<br>\n";
	if (Request.Form.Count == 0){
		msg += "No data<br>\n";
	} else {
		msg += "Data count = " + Request.Form.Count + "<br>\n";
		msg += "<table border=\"1\">\n";
		msg += "<tr><th>parameter</th><th>count</th><th>array</th></tr>\n";
		for (var i = 1; i <= Request.Form.Count; i++) {
			var key   = Request.Form.Key(i);
			var value = Request.Form.Item(key);
			for (var j = 1; j <= value.Count; j++) {
				msg += "<tr><td>" + key + "</td><td>" + j + "</td><td>" + value.Item(j) + "</td></tr>\n";
			}
		}
		msg += "</table>\n";
	}
	RuntimeDebugMessage(msg);
}


function debugPrintObscuredData()
{
	var msg = "";
	msg += "Obscured Data<br>\n";
	if (Request("$connect").Count == 0) {
		msg += "No data<br>\n";
	} else {
		var connect = unobscure(Request("$connect"));
		var source = unobscure(Request("$source"));
		var datatypes = unobscure(Request("$datatypes"));
		msg += "<table border=\"1\">\n";
		msg += "<tr><td>$connect</td><td>" + connect + "</td></tr>\n";
		msg += "<tr><td>$source</td><td>" + source + "</td></tr>\n";
		msg += "<tr><td>$datatypes</td><td>" + datatypes + "</td></tr>\n";
		msg += "</table>\n";
	}
	RuntimeDebugMessage(msg);
}


// *****************************************************************************
// CONTENT SOURCE WRAPPERS
//
// GoLive supports a standard interface definition for a content source.  Other
// objects are wrapped in this interface to allow access.
//
// Content Source Wrapper Properties:
//
//	  Name
//		 the name of CSW itself
//	  RecordCount
//		 the number of records in the recordset
//	  AbsolutePosition
//		 the (1-based) index of the current record (the cursor position)
//	  FirstRecordOnPage
//		 the (1-based) index of the first record on the current page
//    LastRecordOnPage
//		 the (1-based) index of the last record on the current page
//	  BlockSize
//       the number of records in a page
//	  EOB
//       true if the cursor is after the last record on the current page
//	  EOF
//		 true if the cursor is after the last record
//
// Content Source Wrapper Methods:
//
//	  Move(delta)
//		 moves the cursor by the specified amount
//	  MoveFirst()
//		 moves the cursor to the first record
//	  MoveNext()
//		 moves the cursor to the next record
//
//	  Value(fieldName)
//		 returns the value of a field of the current record
//	  Error(fieldName)
//		 returns any error string associated with a field of the current record
//
//	  Key()
//		 returns a key indentifying the current record
//

// -----------------------------------------------------------------------------
// Methods shared by many Content Source Wrappers.

function CSW_Move(delta)
{
	this.AbsolutePosition += delta;
	csw_FixCursor(this);
	this.dup_hack = -1;
}

function CSW_MoveFirst()
{
	this.AbsolutePosition = 1;
	csw_FixCursor(this);
	this.dup_hack = -1;
}

function CSW_MoveNext()
{
	this.Move(1);
	this.dup_hack = -1;
}

function CSW_Error()
{
	return "";
}

function CSW_NOP()
{
}

/*
 * Support function -- not a class method.
 */
function csw_FixCursor(csw) {
	var ix = csw.AbsolutePosition;
	csw.EOF = ix > csw.RecordCount;
	csw.EOB = ix > csw.LastRecordOnPage;
}

/*
 * Move the cursor to absolute position NIX.
 * Not a class method, but maybe should be.
 */
function csw_MoveTo(csw, nix) {
	/*
	 * Sources that don't offer arbitrary positioning still
	 * let you rewind to the beginning.
	 */
	csw.dup_hack = -1;
	if (nix < csw.AbsolutePosition)
		csw.MoveFirst();
	if (nix != csw.AbsolutePosition)
		csw.Move(nix - csw.AbsolutePosition);
}


/*
 * Move the cursor to end.  Make content source return null strings.
 * This function is called explicitly by hand-written code.
 * Not a class method.
 */
function MoveToEnd (csw) {
    csw_MoveTo (csw, csw.RecordCount+1);
}


/**
 ** CSWFormError content source
 **/

/*
 * Top-level routines: use NewError to create, StoreError to
 * stash in the session data, GetError to extract.
 * StoreError and GetError are actually in utils.
 */

function NewError(records) {
	var csw = new CSWFormError();
	if (Request("$cswName")) {
		csw.Name = Request("$cswName");
	} else {
		csw.Name = "unknown";
	}
	csw.LoadDollarDataFromForm();
	csw.LoadFormData();
	/* ignore RECORDS parameter */
	csw.MoveFirst();
	return csw;
}

/*
 * CSWFormError content source wrapper
 * See utils.runtime6.asp for the CSW interface definition.
 */
function CSWFormError() {
	/* CSW interface */
	this.Error = CSWFormError_Error;
	this.Move = CSW_Move;
	this.MoveFirst = CSW_MoveFirst;
	this.MoveNext = CSW_MoveNext;
	this.Value = CSWFormError_Value;

	/* CSW data */
	this.RecordCount = 0;
	this.AbsolutePosition = 1;
	this.FirstRecordOnPage = 1;
	this.LastRecordOnPage = 0;
	this.BlockSize = 1;
	this.EOB = true;
	this.EOF = true;

	/* CSWFormError methods */
	this.ChangeValue = CSWFormError_ChangeValue;
	this.LoadDollarDataFromForm = CSWFormError_LoadDollarDataFromForm;
	this.LoadFormData = CSWFormError_LoadFormData;
	this.SetError = CSWFormError_SetError;

	/* CSWFormError data */
	this.dollar = new Array();
	this.data = new Array();
	this.errors = new Array();
}

function CSWFormError_ChangeValue(fieldName, val) {
	var ix = this.AbsolutePosition;
	if (ix < this.FirstRecordOnPage || this.LastRecordOnPage < ix)
		return;
	if (!this.data[ix])
		this.data[ix] = new Array();
	this.data[ix][fieldName] = val;
}

/*
 * Retrieve the error message associated with field FIELDNAME in the
 * current row, or "" if no message.
 */
function CSWFormError_Error(fieldName) {
	var ix = this.AbsolutePosition;
	if (ix < this.FirstRecordOnPage || this.LastRecordOnPage < ix
	 || !this.errors || !this.errors[ix] || !this.errors[ix][fieldName])
		return "";
	return this.errors[ix][fieldName];
}

/*
 * Find request parameters like "$NAME" and store them in our dollar array.
 */
function CSWFormError_LoadDollarDataFromForm() {
	for (var e = new Enumerator(Request.Form); !e.atEnd(); e.moveNext()) {
		var name = String(e.item());
		if (name.charAt(0)=="$")
			this.dollar[name] = Request(name);
	}
}

/*
 * Find request parameters like "NAME[I]" and construct an array such that
 * the I'th row is an array of items indexed by the various NAMEs.
 */
function CSWFormError_LoadFormData() {
	var re = /^(.+)\[(\d+)\]$/;
	var loIX = 700514, hiIX = -700514;	/* happy birthday adl */
	for (var e = new Enumerator(Request.Form); !e.atEnd(); e.moveNext()) {
		var name = String(e.item());
		if (!re.test(name))
			continue;
		var fieldName = RegExp.$1;
		var ix = Number(RegExp.$2);
		var val = GetFormValue(name);
		if (val=="_no_form_value")
			continue;
		if (!this.data[ix])
			this.data[ix] = new Array();
		this.data[ix][fieldName] = val;
		if (loIX > ix)
			loIX = ix;
		if (hiIX < ix)
			hiIX = ix;
	}
	if (loIX != 700514) {
		this.RecordCount = hiIX;
		this.FirstRecordOnPage = loIX;
		this.LastRecordOnPage = hiIX;
		this.BlockSize = hiIX-loIX+1;
	}
	csw_FixCursor(this);
}

/*
 * Mark the FIELDNAME field in the current row with the error message
 * VAL, retrievable via this.Error(FIELDNAME).
 */
function CSWFormError_SetError(fieldName, val) {
	var ix = this.AbsolutePosition;
	if (ix < this.FirstRecordOnPage || this.LastRecordOnPage < ix)
		return;
	if (!this.errors[ix])
		this.errors[ix] = new Array();
	this.errors[ix][fieldName] = val;
}

function CSWFormError_Value(fieldName) {
	var ix = this.AbsolutePosition;
	if (ix < this.FirstRecordOnPage || this.LastRecordOnPage < ix
	 || !this.data[ix][fieldName])
		return null;
	return this.data[ix][fieldName];
}


/*
 * Support for CSWError needed by all content source types.
 */
function GetError() {
	return Request(FORMERR_NAME).Count > 0
		? Session(FORMERR_NAME)
		: null;
}

function StoreError(csw) {
	Session(FORMERR_NAME) = csw;
}


// *****************************************************************************
// UTILITY FUNCTIONS
//

// -----------------------------------------------------------------------------
// Return the path to the datasources folder.  The only tricky part is finding
// the config folder, which we pluck out of the include path of the current file.
//
// If you'd like to place the datasources outside the config folder, you can
// change the body of this routine to return the path to the datasources.  For
// instance:
//	{
//		return "C:\\dataSourcesFolder\\";
//	}

function GetDataSourcePath()
{
	var dataSourcesPath = "";
	var url = String(Request.ServerVariables("URL"));
	var keyword = "DatasourcePath" + url.substring(0, url.lastIndexOf("/"));
	if (dataSourcesPath = Application(keyword)) {
		return dataSourcesPath;
	}

	var fileSystem = new ActiveXObject("Scripting.FileSystemObject");
	var pathTranslated = String(Request.ServerVariables("PATH_TRANSLATED"));
	var currentFile = fileSystem.OpenTextFile(pathTranslated, 1);	// forReading
	var matchExpression = /\s*[<]!--\s*#INCLUDE\s+(FILE|VIRTUAL)="(.*)[\/]include[\/]utils\.runtime[0-9]+\.asp"\s*--[>]/;
	while (!currentFile.AtEndOfStream) {
		if (matchExpression.exec(currentFile.ReadLine())) {
			break;
		}
	}
	if (currentFile.AtEndOfStream) {
		return "";
	}
	if (RegExp.$1 == "FILE") {
		dataSourcesPath = Server.MapPath(".") + "/" + RegExp.$2;
	} else {
		dataSourcesPath = Server.MapPath(RegExp.$2);
	}
	dataSourcesPath += "/datasources/";
	Application(keyword) = dataSourcesPath;	// cache
	return dataSourcesPath;
}


// -----------------------------------------------------------------------------
// Get the connection string for a datasource.

function GetConnectString(db)
{
	var fileSystem = new ActiveXObject("Scripting.FileSystemObject");
	var dataSourcesPath = GetDataSourcePath();
	if (dataSourcesPath == "") {
		return;
	}
	dataSourcesPath += db;

	if (fileSystem.FileExists(dataSourcesPath + ".udl")) {
		return "File Name=" + dataSourcesPath + ".udl";
	} else if (fileSystem.FileExists(dataSourcesPath + ".dsn")) {
		return "FILEDSN=" + dataSourcesPath + ".dsn";
	} else if (fileSystem.FileExists(dataSourcesPath + ".mdb")) {
		return "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + dataSourcesPath + ".mdb";
	} else if (fileSystem.FileExists(dataSourcesPath + ".xdb")) {
		return "DSN=" + fileSystem.GetBaseName(dataSourcesPath);
	} else {
		return "";
	}
}

function ConnectString(db) { return GetConnectString(db); }	// version 1.0 compatibility

function GetFormValue(name)
{
	var r = null;
	if ((r=Request(name)).Count > 0
	 || (r=Request("~"+name)).Count > 0
	 || (r=Request(name+".x")).Count > 0)
		return unescape(r);
	/* None of the above. */
	return "_no_form_value";
}

/*
 * Use internet-standard newlines to send/receive the contents of
 * text files to/from GoLive.
 */
function canonicalizeCRLF(data) {
	return String(data).replace(/\r\n?|\n/g, "\r\n");
}

/*
 * Read FILENAME into an array of lines and return it.
 * Try to conform to any/all of MacOS (\r) UNIX (\n)
 * and Windows (\r\n) line-ending conventions.
 * The returned lines do not have the line terminator appended;
 * this seems to match the TextStream.ReadLine() method that
 * this function replaces.
 * NB there may be a 0-length last line, an implementation
 * artifact of String.split().
 */
function GL_FileFromTextStream(ts) {
	var content = ts.ReadAll();
	return content.split(/\r\n?|\n/);
}


// *****************************************************************************
// DYNAMIC LINKING

// -----------------------------------------------------------------------------
// Add query parameters to a href.	The function takes a variable number of
// arguments which must consist of alternating names and values.

function URLArgs()
{
	var args = new Array;
	for (var i = 0; i < arguments.length; i += 2) {
		args[Server.URLEncode(arguments[i])] = Server.URLEncode(arguments[i + 1]);
	}
	return queryArrayToString(args);
}

// -----------------------------------------------------------------------------
// Split up a string of the form "arg1=val1&...&argN=valN" into an array
// of argument value pairs.

function queryStringToArray(queryString)
{
	if (queryString == "" || typeof(queryString) == "undefined") {
		return new Array;
	}
	var queryArray = new Array;
	var args = String(queryString).split("&");
	for (var i = 0; i < args.length; i++) {
		var pair = args[i].split("=");
		queryArray[pair[0]] = typeof(pair[1]) == "undefined" ? "" : pair[1];
	}
	return queryArray;
}

// -----------------------------------------------------------------------------
// Construct a query string from an array of key value pairs.

function queryArrayToString(queryArray)
{
	var args = new Array;
	var i = 0
	for (var x in queryArray) {
		if (queryArray[x] == null) {
			args[i] = x;
		} else {
			args[i] = x + "=" + queryArray[x];
		}
		i++;
	}
	return args.join("&");
}

// -----------------------------------------------------------------------------
// Remove all record index and key information from a query array by cswName

function resetRecordNavigation(queryArray, cswName)
{
	var remove = new Array;
	var cswParam    = "[" + cswName + "]";
	var cswParamEsc = escape(cswParam);

	for (var param in queryArray) {
		if ((param.indexOf(cswParam) != -1) || (param.indexOf(cswParamEsc) != -1)) {
			remove[remove.length] = param;
		}
	}

	var newArray = new Array;
paramloop:
	for (var param in queryArray) {
		for (var i = 0; i < remove.length; i++) {
			if (param == remove[i]) {
				continue paramloop;
			}
		}
		newArray[param] = queryArray[param];
	}
	return newArray;
}

// -----------------------------------------------------------------------------
// Turn an application-relative path into a file-relative path

function mapPath(path, relativePathToApplicationRoot)
{
	if (String(path).charAt(0) != '/' && String(path).charAt(0) != '\\') {
		path = '/' + path;
	}
	return String(relativePathToApplicationRoot) + path;
}

// -----------------------------------------------------------------------------
// Turn an relative path into an absolute path

function absolutePath(basePath, relativePath)
{
	if (String(relativePath).charAt(0) == '/') {
		return relativePath;
	}

	var origurl = String(basePath).split("?");
	var newurl = String(relativePath).split("?");

	var origparts = String(origurl[0]).split("/");
	var newparts = String(newurl[0]).split("/");

	var origargs;
	if (origurl.length > 1) {
		origargs = String(origurl[1]).split("&");
	} else {
		origargs = new Array();
	}
	var newargs;
	if (newurl.length > 1) {
		newargs = String(newurl[1]).split("&");
	} else {
		newargs = new Array();
	}

	var finalparts;
	var part = new String(newparts[0]);
	if (part.charAt(part.length - 1) == ":") {	// absolute href
		finalparts = newparts;
	} else {
		origparts = origparts.slice(0, -1);		// first we'll get rid of the last part
		while (newparts[0] == "..") {
			origparts = origparts.slice(0, -1);	// get rid of the last part
			newparts = newparts.slice(1);		// get rid of the ".."
		}
		finalparts = origparts.concat(newparts);
	}

	var finalargs = origargs.concat(newargs);
	return finalparts.join("/").concat("?").concat(finalargs.join("&"));
}

// -----------------------------------------------------------------------------
// Add arguments to a url.	New values replace old values.

function addArgs(url, newArgs)
{
	var urlString = String(url);

	if (newArgs == "") {
		return urlString;
	}
	var i = urlString.indexOf("?");
	if (i == -1) {
		return urlString + "?" + newArgs;
	}
	var urlBase = urlString.substr(0, i);
	var oldArgs = urlString.substr(i + 1);
	var values = queryStringToArray(oldArgs);
	var newValues = queryStringToArray(newArgs);
	for (var x in newValues) {
		values[x] = newValues[x];
	}
	return urlBase + "?" + queryArrayToString(values);
}


// *****************************************************************************
// RECORD NAVIGATION
//
// These functions support "prev" and "next" links on record-oriented content
// sources.
//

// -----------------------------------------------------------------------------
// Create a link to the current page with a specified record index, preserving
// all other query parameters.

function linkToRecord(csw, index, force)
{
	/*
	 * If it's a navigator, do something special
	 */
	while (typeof(csw.viewed_csw) != 'undefined') {
		csw = csw.viewed_csw;
		index = (index-1)*csw.BlockSize + 1;
	}

	/*
	 * Discard if new index is off the end of the content source,
	 * or points back into the current page.
	 */
	if (typeof(force) == 'undefined') {
		if (index < 1 || csw.RecordCount < index
		        || (csw.FirstRecordOnPage <= index && index <= csw.LastRecordOnPage))
			return '';
	}

	var queryArray = queryStringToArray(String(Request.QueryString));

	var param = "RECORD_INDEX[" + csw.Name + "]";
	queryArray = resetRecordNavigation(queryArray, csw.Name);
	queryArray[urlencode(param)] = urlencode(index);

	return " href=\"" + Request.ServerVariables("URL") + "?" + queryArrayToString(queryArray) + "\"";
}


// -----------------------------------------------------------------------------
// Create a link to the previous record in a record-oriented content source.

function LinkToPreviousRecord(csw)
{
	var index = csw.FirstRecordOnPage - ((csw.BlockSize > 1) ? csw.BlockSize : 1);

	return linkToRecord(csw, index);
}

// -----------------------------------------------------------------------------
// Create a link to the next record in a record-oriented content source.

function LinkToNextRecord(csw)
{
	var index = csw.FirstRecordOnPage + ((csw.BlockSize > 1) ? csw.BlockSize : 1);

	return linkToRecord(csw, index);
}

// -----------------------------------------------------------------------------
// Create a link to the first record in a record-oriented content source.

function LinkToFirstRecord(csw)
{
	return linkToRecord(csw, 1);
}

// -----------------------------------------------------------------------------
// Create a link to the last record in a record-oriented content source.

function LinkToLastRecord(csw)
{
	var index = 0;
	if (csw.BlockSize > 1) {
		var blocks = Math.ceil(csw.RecordCount / csw.BlockSize);
		index = ((blocks - 1) * csw.BlockSize) + 1;
	} else {
		index = csw.RecordCount;
	}

	return linkToRecord(csw, index);
}

// -----------------------------------------------------------------------------
// For version 1.0 compatibility

function linkToPreviousRecord(csw)	{ return LinkToPreviousRecord(csw); }
function linkToNextRecord(csw)		{ return LinkToNextRecord(csw); }
function linkToNewRecord(csw)		{ return LinkToNewRecord(csw); }
function linkToFirstRecord(csw)		{ return LinkToFirstRecord(csw); }
function linkToLastRecord(csw)		{ return LinkToLastRecord(csw); }

// -----------------------------------------------------------------------------
// Create a link to detail record

function AddRecordKey(csw)
{
	return "RECORD_KEY[" + csw.Name + "]=" + csw.Key();
}

function AddNewRecordKey(csw)
{
	return "RECORD_KEY[" + csw.Name + "]=" + "$newRecord";
}


// *****************************************************************************
// CONDITIONS

function FirstRecord(csw)
{
	return (csw.FirstRecordOnPage == 1);
}

function LastRecord(csw)
{
	return (csw.LastRecordOnPage == csw.RecordCount);
}

function NoRecords(csw)
{
	return (csw.RecordCount == 0);
}

function RecordCountGreaterThan(csw, cmpValue)
{
	return (csw.RecordCount > cmpValue);
}

function HasError(errorField)
{
	return (String(errorField).length > 0);
}

function ReturnTrue()
{
	return true;
}

function MatchField(field, conditionEnum, value)
{
	var result = false;
	switch(conditionEnum) {
		case 1:	//	=
			if(field == value) {
				result = true;
			}
			break;
		case 2:	//	<>
			if(field != value) {
				result = true;
			}
			break;
		case 3:	//	<
			if(field < value) {
				result = true;
			}
			break;
		case 4:	//	>
			if(field > value) {
				result = true;
			}
			break;
		case 5:	//	<=
			if(field <= value) {
				result = true;
			}
			break;
		case 6:	//	>=
			if(field >= value) {
				result = true;
			}
			break;
		case 7:	//	like
			if(String(field).indexOf(String(value)) >= 0) {
				result = true;
			}
			break;
		case 8:	//	in
			if(String(value).indexOf(String(field)) >= 0) {
				result = true;
			}
			break;
	}
	return result;
}

function IsTrue(expression)
{
	return expression;
}

function FieldIsEmpty(val)
{
	return typeof(val) == 'undefined' || val == null || val == '';
}

// *****************************************************************************
// MISCELLANEOUS

// -----------------------------------------------------------------------------
// Used to conditionally genrate "selected" and "checked" attributes for <form>
// controls:

function Selected(condition)
{
	if (typeof(condition) == 'undefined' || condition == 'undefined'
	        || condition == null || condition == '' || condition == 0) {
		return "";
	} else {
		return "selected";
	}
}

function Checked(condition)
{
	if (typeof(condition) == 'undefined' || condition == 'undefined'
	        || condition == null || condition == '' || condition == 0) {
		return "";
	} else {
		return "checked";
	}
}

/*
 * Returns an XML comment with TEXT properly escaped: "--" can't
 * appear literally, because it will terminate the comment.
 */
function xmlComment(text) {
	var escaped = String(text).replace(/-\055/g, "-&#45;");
	return "<\041-\055 " + escaped + " -\055>";
}

function xmlEncode(text) {
	text = String(text).replace(/\&/g, "&#38;");
	text = text.replace(/</g, "&#60;");
	text = text.replace(/>/g, "&#62;");
	text = text.replace(/'/g, "&#39;");
	text = text.replace(/"/g, "&#34;");
	return text;
}

// -----------------------------------------------------------------------------
// For version 1.0 compatibility

function selected(condition)		{ return Selected(condition); }
function checked(condition)				{ return Checked(condition); }


// -----------------------------------------------------------------------------
// Used to show <form> errors:

function showError(msg)
{
	if (HasError(msg)) {
		return "class='error'";
	} else {
		return "";
	}
}


// -----------------------------------------------------------------------------
// Generates alternating attributes for table cells.

function Alternate(recordNumber, attrName, attrSpec)
{
	var attrRuns = String(attrSpec).split(",");
	var totalCount = 0;
	for (var i = 0; i < attrRuns.length; i++) {
		attrRuns[i] = attrRuns[i].split(":");
		totalCount += Number(attrRuns[i][0]);
	}

	var rowIndex = (recordNumber - 1) % totalCount;
	var runIndex = 0;
	var runCount = Number(attrRuns[runIndex][0]);
	while (runCount <= rowIndex) {
		runIndex++;
		if (runIndex == attrRuns.length) {
			runIndex = 0;
		}
		runCount += Number(attrRuns[runIndex][0]);
	}
	var value = attrRuns[runIndex][1];

	if (value == "_no_attr") {
		return "";
	} else {
		return attrName + "=\"" + value + "\"";
	}
}


// -----------------------------------------------------------------------------
// Set the header to redirect to URL and exit.
// To do: write Forward(url) to call Server.Transfer() on a relative
// URL -- we need to know if the target is "in" our site, so we need
// real site info.

function Redirect(url) {
	if (RuntimeDebug) {	//	no redirection in debug mode.
		RuntimeDebugMessage("Redirect URL = [<a href=\"" + url + "\">" + url +"</a>]<p>\n");
	} else {	//	no redirection in debug mode.
		Response.Redirect(url);
	}
	Response.End();
}


// *****************************************************************************
// HTML ENCODING/DECODING FOR VBSCRIPT

function encodeHTML(text)
{
	return urlencode(text);
}

function decodeHTML(text)
{
	return unescape(text);
}

// -----------------------------------------------------------------------------
// Encode a string in application/x-www-form-urlencoded form.
//
// This function leaves some non-alphanumeric characters unencoded, but it
// correctly encodes '+', '&', and '=', and so works correctly with the ASP query
// string decoding.

function urlencode(text)
{
	var encodedText = escape(text);
	encodedText = encodedText.replace(/\+/g, "%2B");
	return encodedText;
}


// *****************************************************************************
// HTML CONVERT LINE ENDINGS

function ConvertLineEndings(text, convertNBSP, convertBR, convertP,
	encodeHTMLFlag)
{
	var theStr = new String(text);

   	if (encodeHTMLFlag != 0) {
		theStr = Server.HTMLEncode(theStr);
	}

	if (convertP > 0) {
		if (theStr.search(/\r\n/) > -1) {
		        theStr = theStr.replace(/\r\n\r\n/g, "<P>");
		}
		else if (theStr.search(/\r/) > -1) {
		// cover all the cases...
			theStr = theStr.replace(/\r\r/g, "<P>");
 		}
		else if (theStr.search(/\n/) > -1) {
			theStr = theStr.replace(/\n\n/g, "<P>");
		}
	}

	if (convertBR > 0) {
		if (theStr.search(/\r\n/) > -1) {
		        theStr = theStr.replace(/\r\n/g, "<BR>");
		}
		else if (theStr.search(/\r/) > -1) {
		// cover all the cases...
			theStr = theStr.replace(/\r/g, "<BR>");
 		}
		else if (theStr.search(/\n/) > -1) {
			theStr = theStr.replace(/\n/g, "<BR>");
		}
	}

	if (convertNBSP > 0) {
		if (theStr.search(/\t/) > -1)
			theStr = theStr.replace(/\t/g, "    ");
		if (theStr.search(/   /) > -1)
			theStr = theStr.replace(/   /g, "&nbsp;&nbsp; ");
		if (theStr.search(/  /) > -1)
			theStr = theStr.replace(/  /g, "&nbsp; ");
		if (theStr.search(/ &nbsp;/) > -1)
			theStr = theStr.replace(/ &nbsp;/g, "&nbsp;&nbsp;");
	}

	return theStr;
}


// *****************************************************************************
// SECURITY

function RejectUnauthorizedCallers()
{
	var caller = String(Request.ServerVariables("REMOTE_ADDR")).split(".");
	var fso = Server.CreateObject("Scripting.FileSystemObject");
	var currentFile = fso.OpenTextFile(Request.ServerVariables("PATH_TRANSLATED"), 1);	// forReading
	var matchExpression = /\s*[<]!--\s*#INCLUDE\s+(FILE|VIRTUAL)="(.*)[\/]include[\/]utils.runtime[0-9]+.asp"\s*--[>]/;
	while (!currentFile.AtEndOfStream) {
		if (matchExpression.exec(currentFile.ReadLine())) {
			var friendsPath;
			if (RegExp.$1 == "FILE") {
				friendsPath = Server.MapPath(".") + "/" + RegExp.$2 + (RegExp.$2 != "" ? "/":"") + "include/friends.asp";
			} else {
				friendsPath = Server.MapPath(RegExp.$2) + (RegExp.$2 != "" ? "/":"") + "include/friends.asp";
			}

			if (fso.FileExists(friendsPath)) {
				var ts = fso.OpenTextFile(friendsPath, 1);	// forReading
				var lines = GL_FileFromTextStream(ts);
				ts.Close();
				for (var lnum = 0; lnum < lines.length; ++lnum) {
					var line = lines[lnum];
					if ((line.length == 0) || (line.charAt(0) == ";") || (line.charAt(0) == "<")) {
						continue;
					}
					var splitline = line.split(/\s/);
					var kosherAddr = splitline[0].split(".");
					var kosherMask = (splitline.length > 1) ? splitline[1].split(".") : new Array(255, 255, 255, 255);
					var kosher = true;
					var i;
					for (i in caller) {
						if (kosherAddr[i] != (caller[i] & kosherMask[i])) {
							kosher = false;
							break;
						}
					}
					if (kosher) {
						return;
					}
				}
			} else if ((caller[0] == 127) && (caller[1] == 0) && (caller[2] == 0) && (caller[3] == 1)) {
				return;
			}
			break;
		}
	}

	Response.Status = "403 Forbidden";
	Response.Write("You are not authorized to access this page. Check with your Web administrator to make sure your machine is listed in the include/friends.asp file.");
	Response.End();
}


// -----------------------------------------------------------------------------
// These functions allow the passing of sensitive information over a URL.  They
// record the information in the Application object, and pass a hash key to it.

function obscure(plaintext)
{
	var plain = "obscure_" + escape(plaintext);
	if (typeof(Application(plain)) == "undefined") {
		Application(plain) = String(Math.random());
		Application("obscure_" + Application(plain)) = plaintext;
	}
	return Application(plain);
}

function unobscure(hash)
{
	return Application("obscure_" + String(hash));
}

</SCRIPT>

