<?xml version='1.0'?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<!--
  - ADOBE SYSTEMS INCORPORATED
  - Copyright 2001-2002 Adobe Systems Incorporated. All Rights Reserved.
  - 
  - NOTICE:  Notwithstanding the terms of the Adobe GoLive End User 
  - License Agreement, Adobe permits you to reproduce and distribute this 
  - file only as an integrated part of a web site created with Adobe 
  - GoLive software and only for the purpose of enabling your client to 
  - display their web site. All other terms of the Adobe license 
  - agreement remain in effect.
  -->

	<!--
	  - Output of the custommerchant test cart:
	  -
	  -		<custommerchant-result>
	  -			<shopping-cart>
	  -				[<item>
	  -					[<field>...]*
	  -				]*
	  -
	  - Output of the custommerchant test order form:
	  -
	  -		<custommerchant-result>
	  -			<order-form>
	  -				[<field>...]*
	  -
	  -
	  - Format of an info6 test result:
	  -
	  -		<TESTRESULT>
	  -			[<RECORD>
	  -				[<FIELD COLUMN="columnname">columnvalue</FIELD>]*
	  -			]*
	  -
	  -->

	<xsl:template name="crlf">
		<xsl:text disable-output-escaping='yes'>&#13;&#10;</xsl:text>
	</xsl:template>

	<xsl:template match="/">
		<xsl:apply-templates/>
	</xsl:template>

	<xsl:template match="shopping-cart">
		<TESTRESULT><xsl:call-template name="crlf"/>
		<xsl:for-each select="item">
			<RECORD><xsl:call-template name="crlf"/>
			<xsl:for-each select="*">
				<FIELD>
				<xsl:attribute name="COLUMN">
					<xsl:copy-of select="name()"/>
				</xsl:attribute>
				<xsl:copy-of select="text()"/>
				</FIELD><xsl:call-template name="crlf"/>
			</xsl:for-each>
			</RECORD>
		</xsl:for-each>
		</TESTRESULT>
	</xsl:template>

	<xsl:template match="order-form">
		<TESTRESULT><xsl:call-template name="crlf"/>
			<RECORD><xsl:call-template name="crlf"/>
			<xsl:for-each select="*">
				<FIELD>
				<xsl:attribute name="COLUMN">
					<xsl:copy-of select="name()"/>
				</xsl:attribute>
				<xsl:copy-of select="text()"/>
				</FIELD><xsl:call-template name="crlf"/>
			</xsl:for-each>
			</RECORD>
		</TESTRESULT>
	</xsl:template>

	<xsl:template match="*">
		<xsl:apply-templates/>
	</xsl:template>

</xsl:stylesheet>
