<%@ Language="VBScript" %>
<!-- #INCLUDE VIRTUAL="/samples/config/include/utils.runtime6.asp" -->
<!-- #INCLUDE VIRTUAL="/samples/config/include/custommerchant.runtime6.asp" -->

<script runat="server" language="JScript">

//
// For some reason, this doesn't work in VBScript....
//
function GetTransform()
{
    var doc = new ActiveXObject("MSXML2.DOMDocument");
    doc.async = false;
    doc.load(Server.MapPath("custommerchant.xform.info6.xsl"));
    return doc;
}

</script>

<%

' *****************************************************************************
'
' info/custommerchant.order.info6.asp
'
' GoLive design-time support for CustomMerchant order forms.
'
'
' ADOBE SYSTEMS INCORPORATED
' Copyright 2001-2002 Adobe Systems Incorporated. All Rights Reserved.
'
' NOTICE:  Notwithstanding the terms of the Adobe GoLive End User 
' License Agreement, Adobe permits you to reproduce and distribute this 
' file only as an integrated part of a web site created with Adobe 
' GoLive software and only for the purpose of enabling your client to 
' display their web site. All other terms of the Adobe license 
' agreement remain in effect.


' -----------------------------------------------------------------------------
' Return an XML document containing information about the CustomMerchant order
' form datasources available.  Valid requests are:
'
'	custommerchant.order.info6.asp?datasources=<all|distinct>
'		return a list of e-commerce cart providers
'		ex) .../custommerchant.order.info6.asp?datasources=all
'		ex) .../custommerchant.order.info6.asp?datasources=distinct
'
'	custommerchant.order.info6.asp?provider=<provider-name>
'		return the schema of an order form from a specific provider
'		ex) .../custommerchant.order.info6.asp?provider=Adobe

RejectUnauthorizedCallers
Response.ContentType = "text/xml"
if not RuntimeDebug then
	on error resume next
end if

if IsEmpty(Request("provider")) then
	WriteProviders(Request("datasources") = "all")
elseif Not IsEmpty(Request("test")) then	' must come before WriteOrderFormSchema
	WriteTestOrderForm Request("provider")
else
	WriteOrderFormSchema Request("provider")
end if

if Err then
	WriteError
end if

' -----------------------------------------------------------------------------
' Write out the list of available providers.  XML format:
'
'		<DATASOURCES>
'			[<DATASOURCE>...]*

function WriteProviders(all)

	dim fileSystem
	dim folder
	dim file
	dim baseName
	dim prevName

	set fileSystem = CreateObject("Scripting.FileSystemObject")
	set folder = fileSystem.GetFolder(GetDataSourcePath())

	Response.Write "<DATASOURCES>" & vbCrLf
	for each file in folder.files
		if ucase(fileSystem.GetExtensionName(file)) = "ECP" then
			baseName = fileSystem.GetBaseName(file)
			if all then
				Response.Write "    <DATASOURCE>" & baseName & ".ecp</DATASOURCE>" & vbCrLf
			elseif baseName <> prevName then
				Response.Write "    <DATASOURCE>" & baseName & "</DATASOURCE>" & vbCrLf
				prevName = baseName
			end if
		end if
	next
	Response.Write "</DATASOURCES>" & vbCrLf

end function

' -----------------------------------------------------------------------------
' Write out the the schema of an order form.  XML format:
'
'		<STRUCTURE>
'			[<FIELD>
'				<NAME>...
'				[<FRIENDLY-NAME>...]?
'			]*

function WriteOrderFormSchema(provider)

	set providerInfo = GetProviderInfo(provider)
	query = "action=get-order-schema&merchant-id=" & providerInfo.merchantId
	set dom = GetHTTPResults(providerInfo.url, query)
	Response.Write dom.documentElement.firstChild.xml

end function

' -----------------------------------------------------------------------------
' Write out a test order form.  XML format:
'
'		<TESTRESULT>
'			[<RECORD>
'				[<FIELD COLUMN="columnname">columnvalue</FIELD>]*
'			]*

function WriteTestOrderForm(provider)

	set xform = GetTransform()

	set providerInfo = GetProviderInfo(provider)
	query = "action=get-order-form&merchant-id=" & providerInfo.merchantId & "&shopper-id=test"
	set dom = GetHTTPResults(providerInfo.url, query)

	Response.Write dom.transformNode(xform)

end function


' -----------------------------------------------------------------------------
' Write out an error message as XML.

function WriteError

	dim qt

	qt = chr(34)
	Response.Write "<ERROR"
	Response.Write " Number="		& qt	& Err.Number			& qt
	Response.Write " Source="		& qt	& Err.Source			& qt
	Response.Write " Description="	& qt	& Err.Description		& qt
	Response.Write " HelpFile="		& qt	& Err.HelpFile			& qt
	Response.Write " HelpContext="	& qt	& Err.HelpContext		& qt
	Response.Write "/>" & vbCrLf

end function

%>
