<%@ Language="VBScript" %>
<!-- #INCLUDE VIRTUAL="/samples/config/include/utils.runtime6.asp" -->

<script runat="server" language="JScript">

/*
 * ADOBE SYSTEMS INCORPORATED
 * Copyright 2001-2002 Adobe Systems Incorporated. All Rights Reserved.
 * 
 * NOTICE:  Notwithstanding the terms of the Adobe GoLive End User 
 * License Agreement, Adobe permits you to reproduce and distribute this 
 * file only as an integrated part of a web site created with Adobe 
 * GoLive software and only for the purpose of enabling your client to 
 * display their web site. All other terms of the Adobe license 
 * agreement remain in effect.
 */

function GetSet()
{
    return new Set();
}

function Set()
{
    this.Members = new Array();
    this.Add = Set_Add;
}

function Set_Add(member)
{
    this.Members[member] = member;
}

function SafeLoad(url)
{
    /*
    If you try to load an XMLDOM object from an URL it may not work.
    And if you try to get from a file using XMLHTTP it doesn't work.
    And if you use XMLHTTP to get from an URL and the result is XML
    but the Content-Type header says it's something else, the
    responseXML property doesn't work. That's why all this gobbledygook.
    */
    var doc;
    var oldxml = false;
    try
    {
		doc = new ActiveXObject("MSXML2.DOMDocument");
	}
	catch(e) {}
	try
	{
		if (!doc) {
			doc = new ActiveXObject("Microsoft.XMLDOM");
			oldxml = true;
		}
		doc.async = false;
		doc.validateOnParse = false;
		doc.resolveExternals = false;
		url = String(url); // oh, just in case
		if (url.substring(0, 5).toLowerCase() == "http:") {
			if (!doc.load(url)) {
				if (oldxml) {
					var http = new ActiveXObject("Microsoft.XMLHTTP");
					http.open("GET", url, false);
					http.send();
					if (http.responseXML.documentElement) {
					    doc = http.responseXML;
					} else if (!doc.loadXML(http.responseText)) {
						throw new Error(doc.parseError.errorCode, doc.parseError.reason);
					}
				} else {
					doc.setProperty ("ServerHTTPRequest", true);
					if (!doc.load(url)) {
						var http = new ActiveXObject("MSXML2.ServerXMLHTTP");
						http.open("GET", url, false);
						http.send();
					    if (http.responseXML.documentElement) {
					        doc = http.responseXML;
					    } else if (!doc.loadXML(http.responseText)) {
							throw new Error(doc.parseError.errorCode, doc.parseError.reason);
					    }
					}
				}
			}
		} else {
			if (url.indexOf(":") == -1) {
				url = Server.MapPath(url);
			}
		    if (!doc.load(url)) {
				throw new Error(doc.parseError.errorCode, doc.parseError.reason);
			}
		}
		return doc;
	}
	catch(e)
	{
		RaiseError(e.number, e.description);
	}
}

function getLatestXML()
{
    var doc;
    try
    {
		doc = new ActiveXObject("MSXML2.DOMDocument");
	}
	catch(e) {}
	if (!doc) {
		doc = new ActiveXObject("Microsoft.XMLDOM");
	}
	return doc;
}

function AbsolutePath(basePath, relativePath)
{
	var basePath = String(basePath);
	var relativePath = String(relativePath);

	if (relativePath.charAt(0) == '/') {
		return relativePath;
	}

	var origurl = basePath.split("?");
	var newurl = relativePath.split("?");

	var origparts = origurl[0].split("/");
	var newparts = newurl[0].split("/");

	var origargs, newargs;
	if (origurl.length > 1) {
		origargs = origurl[1].split("&");
	} else {
		origargs = new Array();
	}
	if (newurl.length > 1) {
		newargs = newurl[1].split("&");
	} else {
		newargs = new Array();
	}

	var i;
	var finalparts;
	var firstpart = newparts[0];
	if (firstpart.charAt(firstpart.length - 1) == ':') {	// absolute href
		finalparts = newparts;
	} else {
		var keeporig = origparts.length - 1;				// first we'll get rid of the last part
		var startnew = 0;
		while (newparts[startnew] == "..") {
			keeporig--;										// get rid of the last part
			startnew++;										// get rid of the ".."
		}
		finalparts = new Array();
		for (i = 0; i < keeporig; i++) {
			finalparts[finalparts.length] = origparts[i];
		}
		for (i = startnew; i < newparts.length; i++) {
			finalparts[finalparts.length] = newparts[i];
		}
	}

	var finalargs = origargs;
	for (i = 0; i < newargs.length; i++) {
		finalargs[finalargs.length] = newargs[i];
	}

	var abspath = finalparts.join("/");
	if (finalargs.length > 0) {
		abspath += "?" + finalargs.join("&");
	}

	return abspath;
}

/*
What the XDS file looks like:
<GL6XMLSOURCE xslurl="foo.xsl" xmlurl="foo.xml" sample="foobar.xml">
    <NODE name="one" type="hidden-attribute" />
    <NODE name="two" type="hidden-element" />
    <NODE name="three" type="hidden-element">
        <NODE name="three.one" type="attribute" />
    </NODE>
    <NODE name="four" type="attribute" />
    <NODE name="five" type="element" />
    <NODE name="six" type="element">
        <NODE name="six.one" type="element" />
    </NODE>
    <NODE name="seven" type="structure">
        <NODE name="seven.one" type="attribute" />
    </NODE>
    <NODE name="eight" type="rowset">
        <NODE name="eight.one" type="element" />
    </NODE>
</GL6XMLSOURCE>
*/

function DisplayRowset(node, depth)
{
    var patharray = new Array;
    var children = node.selectNodes("*");
	for (var child = children.nextNode(); child; child = children.nextNode()) {
        DisplayNode(child, patharray, depth);
    }
}

function DisplayNode(node, patharray, depth)
{
    var depthstring = Array((depth * 8) + 1).join(" ");
    var name = node.getAttribute("name");
    var fullname;

    switch (node.getAttribute("type"))
    {
    case "attribute":
        patharray[patharray.length] = "@" + name;
        fullname = patharray.join("/");
        patharray.length = patharray.length - 1;

        Response.Write(depthstring + "<FIELD>\n");
        Response.Write(depthstring + "    <NAME>" + fullname + "</NAME>\n");
        Response.Write(depthstring + "</FIELD>\n");
        break;

    case "element":
        if (name == "[body]") {
            patharray[patharray.length] = ".";
        } else {
            patharray[patharray.length] = name;
        }
        fullname = patharray.join("/");
        patharray.length = patharray.length - 1;

        Response.Write(depthstring + "<FIELD>\n");
        Response.Write(depthstring + "    <NAME>" + fullname + "</NAME>\n");
        if (name == "[body]") {
            Response.Write(depthstring + "    <FRIENDLYNAME>");
            if (patharray.length > 0) {
                Response.Write(patharray.join("/"));
            } else {
                Response.Write("[body]");
            }
            Response.Write("</FRIENDLYNAME>\n");
        }
        Response.Write(depthstring + "</FIELD>\n");
        break;

    case "rowset":
        patharray[patharray.length] = name;
        fullname = patharray.join("/");
        patharray.length = patharray.length - 1;

        Response.Write(depthstring + "<FIELD>\n");
        Response.Write(depthstring + "    <NAME>" + fullname + "</NAME>\n");
        Response.Write(depthstring + "    <STRUCTURE>\n");

        DisplayRowset(node, depth + 1);

        Response.Write(depthstring + "    </STRUCTURE>\n");
        Response.Write(depthstring + "</FIELD>\n");
        break;

    case "structure":
        patharray[patharray.length] = name;
        var children = node.selectNodes("*");
	    for (var child = children.nextNode(); child; child = children.nextNode()) {
            DisplayNode(child, patharray, depth);
        }
        patharray.length = patharray.length - 1;
    }
}

function DisplayDOMNode(node)
{
	var children = node.childNodes;
	for (var child = children.nextNode(); child; child = children.nextNode()) {
		switch (child.nodeType)
		{
		case 3:
		case 4:
			Response.Write(child.text);
			break;
		default:
			Response.Write(child.xml);
		}
	}
}

function DisplayNodeValue(element, node, patharray)
{
    var name = node.getAttribute("name");
    var fullname;

    switch (node.getAttribute("type"))
    {
    case "attribute":
        patharray[patharray.length] = "@" + name;
        fullname = patharray.join("/");
        patharray.length = patharray.length - 1;

        Response.Write("        <FIELD COLUMN=\"" + fullname + "\">");
        var DOMnode = element.selectSingleNode(fullname);
        if (DOMnode) DisplayDOMNode(DOMnode);
        Response.Write("        </FIELD>\n");
        break;

    case "element":
        if (name == "[body]") {
            patharray[patharray.length] = ".";
        } else {
            patharray[patharray.length] = name;
        }
        fullname = patharray.join("/");
        patharray.length = patharray.length - 1;

        Response.Write("        <FIELD COLUMN=\"");
        if (name == "[body]") {
            if (patharray.length > 0) {
                Response.Write(patharray.join("/"));
            } else {
                Response.Write("[body]");
            }
        } else {
            Response.Write(fullname);
        }
        Response.Write("\">");
        var DOMnode = element.selectSingleNode(fullname);
        if (DOMnode) DisplayDOMNode(DOMnode);
        Response.Write("        </FIELD>\n");
        break;

    case "structure":
        patharray[patharray.length] = name;
        var children = node.selectNodes("*");
	    for (var child = children.nextNode(); child; child = children.nextNode()) {
            DisplayNodeValue(element, child, patharray);
        }
        patharray.length = patharray.length - 1;
    }
}

function DisplayValues(fields, data)
{
    var patharray = new Array;
	for (var child = fields.nextNode(); child; child = fields.nextNode()) {
        DisplayNodeValue(data, child, patharray);
    }
}

</script>

<%
' *****************************************************************************
'
' info/xml.info6.asp
'
' GoLive design-time support for XML.
'
'
' COPYRIGHT (c) 1999-2000 Adobe Systems Incorporated. All rights reserved.


' -----------------------------------------------------------------------------
' Return an XML document containing information about the datasources available
' for binding via XML.  Valid requests are:
'
'	xml.info6.asp?datasources=<all|distinct>
'		return a list available XML applications
'		ex) .../xml.info6.asp?datasources=all
'		ex) .../xml.info6.asp?datasources=distinct
'
'	xml.info6.asp?dstype=<name>	return the structure of a given datasource
'   xml.info6.asp?xml=<name>&xsl=<opt> return default structure for source
'   xml.info6.asp?get=<name>       return the contents of the XDS file
'   xml.info6.asp?put=<name>&data=<xml> write the contents of the XDS file
'   xml.info6.asp?delete=<name> delete the XDS file
'	xml.info6.asp?dstype=<name>&xml=<url>&test=whatever return the first record

RejectUnauthorizedCallers

response.contenttype = "text/xml"

if False = RuntimeDebug then
	on error resume next
end if

if Len(Request("dstype")) > 0 then
	WriteDataSourceSchema Request("dstype")
elseif Len(Request("get")) > 0 then
    GetRaw Request("get")
elseif Len(Request("put")) > 0 then
    PutRaw Request("put"), Request("data")
elseif Len(Request("xsl")) > 0 then
    TransformAndAnalyze Request("xml"), Request("xsl")
elseif Len(Request("xml")) > 0 then
    Analyze Request("xml")
elseif Request("datasources") = "all" then
	WriteDataSources true
elseif Len(Request("delete")) = 0 then 'this makes this the default if we don't recognize anything
    WriteDataSources false
end if

' this can appear together with any of the others
if Len(Request("delete")) > 0 then
    DeleteRaw Request("delete")
end if

if Err then
	WriteError
end if

sub RaiseError(number, description)
	Err.Raise number, "xml.info6.asp", description
end sub

' -----------------------------------------------------------------------------
' Write out the list of available datasources.  XML format:
'
'		<DATASOURCES>
'			[<DATASOURCE>...]*

sub WriteDataSources(all)
	dim fileSystem
	dim folder
	dim file
	dim baseName
	dim prevName

	set fileSystem = CreateObject("Scripting.FileSystemObject")
	set folder = fileSystem.GetFolder(GetDataSourcePath())

	Response.Write "<DATASOURCES>" & vbCrLf
	for each file in folder.files
		if ucase(fileSystem.GetExtensionName(file)) = "XDS" then
			baseName = fileSystem.GetBaseName(file)
			if all then
				Response.Write "    <DATASOURCE>" & baseName & ".xds</DATASOURCE>" & vbCrLf
			elseif baseName <> prevName then
				Response.Write "    <DATASOURCE>" & baseName & "</DATASOURCE>" & vbCrLf
				prevName = baseName
			end if
		end if
	next
	Response.Write "</DATASOURCES>" & vbCrLf
end sub

' -----------------------------------------------------------------------------
' Write out raw datasource file.

sub GetRaw(dstype)
    dsfilename = GetDataSourcePath() & dstype
    set doc = getLatestXML()
    doc.async = false
    doc.load dsfilename
    Response.Write doc.xml
end sub

' -----------------------------------------------------------------------------
' Write into raw datasource file.

sub PutRaw(dstype, data)
    dsfilename = GetDataSourcePath() & dstype
    set doc = getLatestXML()
    doc.async = false
    doc.loadxml data
    doc.save dsfilename
end sub

' -----------------------------------------------------------------------------
' Delete raw datasource file.

sub DeleteRaw(dstype)
    dsfilename = GetDataSourcePath() & dstype
	set fileSystem = CreateObject("Scripting.FileSystemObject")
	fileSystem.DeleteFile dsfilename, true
end sub

' -----------------------------------------------------------------------------
' Write out datasource schema as XML.

sub WriteDataSourceSchema(dstype)
    dsfilename = GetDataSourcePath() & dstype & ".XDS"
    set doc = getLatestXML()
    doc.async = false
    doc.load dsfilename
	if Len(Request("test")) > 0 then
		xslurl = doc.documentElement.getAttribute("xslurl")
		if doc.documentElement.getAttribute("single") = "true" then
			firstRecord = "/*[0]"
		else
			firstRecord = "/*/*[0]"
		end if
		xmlurl = Request("xml")
		if Len(xmlurl) = 0 then
			xmlurl = doc.documentElement.getAttribute("xmlurl")
		else
			xmlurl = AbsolutePath(Request("test"), xmlurl)
		end if
		set xml = SafeLoad(xmlurl)
		set fields = doc.documentElement.childNodes

		if Len(xslurl) > 0 then
		    xml.transformNodeToObject SafeLoad(xslurl), doc
		else
		    set doc = xml
		end if

		set data = doc.selectSingleNode(firstRecord)

		Response.Write "<TESTRESULT>" & vbCrLf
		Response.Write "    <RECORD NUMBER=""1"">" & vbCrLf
		DisplayValues fields, data
		Response.Write "    </RECORD>" & vbCrLf
		Response.Write "</TESTRESULT>" & vbCrLf
	else
		Response.Write "<STRUCTURE>" & vbCrLf
		DisplayRowset doc.documentElement, 1
		Response.Write "</STRUCTURE>" & vbCrLf
	end if
end sub

' -----------------------------------------------------------------------------
' Analyze documents and write out the default datasource document.

sub Analyze(xmlurl)
    DisplayDoc SafeLoad(xmlurl)
end sub

sub TransformAndAnalyze(xmlurl, xslurl)
    set xml = SafeLoad(xmlurl)
    set xsl = SafeLoad(xslurl)

	set doc = getLatestXML()
	doc.async = False
    xml.transformNodeToObject xsl, doc

    DisplayDoc doc
end sub

sub DisplayDoc(doc)
    Response.Write "<GL6XMLSOURCE xslurl="""
    Response.Write Server.HTMLEncode(Request("xsl"))
    Response.Write """ xmlurl="""
    Response.Write Server.HTMLEncode(Request("xml"))
    Response.Write """ single="""
    Response.Write Server.HTMLEncode(Request("single"))
    Response.Write """>" & vbCrLf

    if Request("single") = "true" then
        Display doc, "/*", 1
    else
        Display doc, "/*/*", 1
    end if

    Response.Write "</GL6XMLSOURCE>" & vbCrLf
end sub

sub Display(doc, path, depth)
    depthstring = String(depth * 4, " ")

    set attribs = doc.selectNodes(path & "/@*")
    set children = doc.selectNodes(path & "/*")

    if (attribs.length + children.length) > 0 then
        Response.Write depthstring & "<NODE name=""[body]"" type=""hidden-element"" />" & vbCrLf

		set fields = GetSet()
		for each attrib in attribs
		    fields.Add attrib.nodeName
		next
        for each field in fields.Members
            Response.Write depthstring & "<NODE name=""" & field & """ type=""attribute"" />" & vbCrLf
        next

		set childNames = GetSet()
		for each child in children
		    childNames.Add child.nodeName
		next
        for each name in childNames.Members
            Response.Write depthstring & "<NODE name=""" & name & """ type=""element"">" & vbCrLf
            Display doc, path & "/" & name, depth + 1
            Response.Write depthstring & "</NODE>" & vbCrLf
        next
    else
        Response.Write depthstring & "<NODE name=""[body]"" type=""element"" />" & vbCrLf
    end if
end sub

' -----------------------------------------------------------------------------
' Write out an error message as XML.

sub WriteError

	dim qt

	qt = chr(34)
	Response.Write "<ERROR"
	Response.Write " Number="		& qt	& Err.Number			& qt
	Response.Write " Source="		& qt	& Err.Source			& qt
	Response.Write " Description="	& qt	& Err.Description		& qt
	Response.Write " HelpFile="		& qt	& Err.HelpFile			& qt
	Response.Write " HelpContext="	& qt	& Err.HelpContext		& qt
	Response.Write "/>" & vbCrLf

end sub

%>

