/*
 * GoLive
 *
 * ADOBE SYSTEMS INCORPORATED
 * Copyright 2000-2002 Adobe Systems Incorporated. All Rights Reserved.
 * 
 * NOTICE:  Notwithstanding the terms of the Adobe GoLive End User 
 * License Agreement, Adobe permits you to reproduce and distribute this 
 * file only as an integrated part of a web site created with Adobe 
 * GoLive software and only for the purpose of enabling your client to 
 * display their web site. All other terms of the Adobe license 
 * agreement remain in effect.
 */

package com.adobe.gl.runtime6.utils;

import java.io.*;
import java.util.*;

public class GLBlockParam {
	public GLBlockParam(String b) {
		int tblksize = -1;
		boolean tvalid = false;
		if ("all".equals(b)) {
			tblksize = 0;
			tvalid = true;
		}
		else if ("single".equals(b)) {
			tblksize = 1;
			tvalid = true;
		}
		else if (b.startsWith("block=")) {
			try {
				int i = 6;
				for (; i < b.length(); ++i) {
					final char c = b.charAt(i);
					if (c < '0' || '9' < c)
						break;
				}
				tblksize = Integer.parseInt(b.substring(6, i));
				tvalid = true;
			}
			catch (NumberFormatException e) {
				tblksize = -1;
				tvalid = false;
			}
		}
		blksize = tblksize;
		valid = tvalid;
	}

	public final boolean valid;
	public final int blksize;
}
