<%--
   - GoLive actions for JDBC data sources.
   -
   - ADOBE SYSTEMS INCORPORATED
   - Copyright 2000-2002 Adobe Systems Incorporated. All Rights Reserved.
   - 
   - NOTICE:  Notwithstanding the terms of the Adobe GoLive End User 
   - License Agreement, Adobe permits you to reproduce and distribute this 
   - file only as an integrated part of a web site created with Adobe 
   - GoLive software and only for the purpose of enabling your client to 
   - display their web site. All other terms of the Adobe license 
   - agreement remain in effect.
  --%>
<%@page session="true"
	import="java.sql.*,java.io.*,java.util.*"
	errorPage="/config/actions/error.jsp"
 %><%@page import="com.adobe.gl.runtime6.utils.*"
 %><%@page import="com.adobe.gl.runtime6.jdbc.*"
 %><%@taglib uri="/gl-taglib" prefix="gl"
 %>
<%--
  -- jdbc.actions6.jsp
  --	Provide the 4 standard actions: $AddRecord, $DeleteRecord,
  --	$DuplicateRecord, $SubmitChanges to add, delete, create,
  --	and update records.
  --%>
<gl:page id='gl'><%
	String s = request.getParameter("$csg");
	if (s == null) {
		response.sendError(400 /* SC_BAD_REQUEST */,
			"Bad request format (missing argument block $csg).");
		return;
	}

	GLJdbcAction jackson = (GLJdbcAction) gl.unintern(s);
	if (jackson==null)
		throw new GLException("jackson==null");
	String tablename = jackson.getTableName();
	Connection con = GLJdbc.getConnection(gl, jackson.dbname);
	ContentSourceWrapper csf = CSWError.newError(gl, null);
	if (gl.getFormValue("$AddRecord") != null)
		AddRecord(gl, con, jackson, tablename, csf);
	else if (gl.getFormValue("$BlankRecord") != null)
		ShowBlankRecord(gl, con, jackson, tablename, csf);
	else if (gl.getFormValue("$DeleteRecord") != null)
		DeleteRecord(gl, con, jackson, tablename, csf);
	else if (gl.getFormValue("$DuplicateRecord") != null)
		DuplicateRecord(gl, con, jackson, tablename, csf);
	else if (gl.getFormValue("$SubmitChanges") != null)
		SubmitChanges(gl, con, jackson, tablename, csf);
	else {
		response.sendError(400 /* SC_BAD_REQUEST */,
			"Bad request format (missing action code).");
	}
 %></gl:page>
<%!
	/*
	 * -- Top-level actions
	 */

	private void
	DeleteRecord(GLContext gl, Connection con, GLJdbcAction jackson,
		String tablename, ContentSourceWrapper csf)
		throws SQLException, IOException, GLException
	{
		String succ = getNamedURL(gl, "delete", "success"),
			fail = getNamedURL(gl, "delete", "failure");
		boolean ok = false;

		if (jackson.key.length != 1)
			quack1(gl, "DeleteRecord", csf);
		else {
			try {
				deleteUsingPostDataDeleteQuery(gl, con,
					jackson, tablename);
				ok = true;
			}
			catch (Throwable e) {
			}
		}

		Hashtable query = null;
		if (!ok) {
			if (jackson.deflink.equals(fail)) {
				fail = jackson.retURI;
				query = jackson.retQuery;
			}
			redirect(gl, fail, query, gl.FAILURE);
			return;
		}
		if (jackson.deflink.equals(succ)) {
			String cname =
				gl.getRequest().getParameter("$cswName");
			String rkname = GLUtils.rk(cname),
				rxname = GLUtils.rx(cname);
			String rkval = (String) jackson.retQuery.get(rkname),
				rxval = (String) jackson.retQuery.get(rxname);
			gl.runtimeDebugMessage("rkname " + rkname
				+ " rkval " + rkval);
			gl.runtimeDebugMessage("rxname " + rxname
				+ " rxval " + rxval);
			query = resetRecordNavigation(jackson.retQuery, gl);
			if ("$lastRecord".equals(rkval))
				query.put(rkname, rkval);
			else {
				int k = GLUtils.queryIndex(jackson.retQuery,
					cname);
				query.put(GLUtils.rx(cname), ""+k);
			}
			succ = jackson.retURI;
		}
		redirect(gl, succ, query, gl.SUCCESS);
	}

	private void
	AddRecord(GLContext gl, Connection con, GLJdbcAction jackson,
		String tablename, ContentSourceWrapper csf)
		throws SQLException, IOException, GLException
	{
		add(gl, con, jackson, tablename, "add", csf);
	}

	private void
	DuplicateRecord(GLContext gl, Connection con, GLJdbcAction jackson,
		String tablename, ContentSourceWrapper csf)
		throws SQLException, IOException, GLException
	{
		String succ = getNamedURL(gl, "duplicate", "success"),
			fail = getNamedURL(gl, "duplicate", "failure");

		Hashtable a = null;
		if (csf.FirstRecordOnPage() != csf.LastRecordOnPage()) {
			quack1(gl, "DuplicateRecord", csf);
			if (jackson.deflink.equals(fail)) {
				fail = jackson.retURI;
				a = jackson.retQuery;
			}
			redirect(gl, fail, a, gl.FAILURE);
			return;
		}

		if (jackson.deflink.equals(succ)) {
			succ = jackson.retURI;
			a = resetRecordNavigation(jackson.retQuery, gl);
			a.put(xk(gl), "$copyRecord");
			a.put(xx(gl), ""+csf.FirstRecordOnPage());
		}
		redirect(gl, succ, a, gl.SUCCESS);
		return;
	}

	private void
	ShowBlankRecord(GLContext gl, Connection con, GLJdbcAction jackson,
		String tablename, ContentSourceWrapper csf)
		throws SQLException, IOException, GLException
	{
		String succ = getNamedURL(gl, "blank", "success"),
			fail = getNamedURL(gl, "blank", "failure");
		boolean ok = false;
		Hashtable a = null;
		if (jackson.deflink.equals(succ)) {
			succ = jackson.retURI;
			a = resetRecordNavigation(jackson.retQuery, gl);
		}
		a.put(xk(gl), "$newRecord");
		redirect(gl, succ, a, gl.SUCCESS);
		return;
	}

	private void
	SubmitChanges(GLContext gl, Connection con, GLJdbcAction jackson,
		String tablename, ContentSourceWrapper csf)
		throws SQLException, IOException, GLException
	{
		gl.runtimeDebugMessage(
			"SubmitChanges: first=" + jackson.firstRecord
			+ " last=" + jackson.lastRecord
			+ " new=" + jackson.newRecord);
		gl.runtimeDebugMessage(
			"SubmitChanges: where=" + jackson.where);
		if (jackson.newRecord)
			add(gl, con, jackson, tablename, "update", csf);
		else
			update(gl, con, jackson, tablename);
	}

	private void
	add(GLContext gl, Connection con, GLJdbcAction jackson,
		String tablename, String opname, ContentSourceWrapper csf)
		throws SQLException, IOException, GLException
	{
		String succ = getNamedURL(gl, opname, "success"),
			fail = getNamedURL(gl, opname, "failure");
		boolean ok = false;

		gl.runtimeDebugMessage("add "+succ+" "+fail+" first "
			+jackson.firstRecord+" last "+jackson.lastRecord);
		if (csf.FirstRecordOnPage() != csf.LastRecordOnPage())
			quack1(gl, "AddRecord", csf);
		else {
			try {
				int n = addRecordUsingPostDataInsertQuery(gl,
					con, jackson, tablename);
				ok = n > 0;
			}
			catch (Throwable e) {
				StringBuffer ts = new StringBuffer();
				GLDebug.reportException(e, ts);
				gl.runtimeDebugMessage("Caught "+e+"\n"+ts);
				ts = null;
			}
		}

		Hashtable query = null;
		if (!ok) {
			if (jackson.deflink.equals(fail)) {
				fail = jackson.retURI;
				query = jackson.retQuery;
			}
			redirect(gl, fail, query, gl.FAILURE);
			return;
		}
		if (jackson.deflink.equals(succ)) {
			succ = jackson.retURI;
			query = resetRecordNavigation(jackson.retQuery, gl);
			query.put(xk(gl), "$lastRecord");
		}
		redirect(gl, succ, query, gl.SUCCESS);
	}

	private void
	update(GLContext gl, Connection con, GLJdbcAction jackson,
		String tablename)
		throws SQLException, IOException, GLException
	{
		String succ = getNamedURL(gl, "update", "success"),
			fail = getNamedURL(gl, "update", "failure");
		boolean ok = false;

		try {
			updateUsingPostDataUpdateQuery(gl, con,
				jackson, tablename);
			ok = true;
		}
		catch (Throwable e) {
			gl.runtimeDebugMessage("update: caught"+e);
		}

		Hashtable query = null;
		String uri = ok ? succ : fail;
		if (jackson.deflink.equals(uri)) {
			query = jackson.retQuery;
			uri = jackson.retURI;
		}
		redirect(gl, uri, query, ok);
	}

	/*
	 * -- Database actions
	 */
	private void
	updateUsingPostDataUpdateQuery(GLContext gl, Connection con,
		GLJdbcAction jackson, String tablename)
		throws SQLException, GLException
	{
		String[] pkey = GLUtils.hkeys(jackson.where);
		String[] whereKeys = null;
		PreparedStatement pst = null;
		try {gl.runtimeDebugMessage("update: starting");
			do {
				if (whereKeys == null)
					whereKeys = (String []) pkey.clone();
				Hashtable sets =
					jackson.getFormData(gl,
						gl.getRequestParameters());
				String[] setKeys = GLUtils.hkeys(sets);
				String s = new StringBuffer()
					.append("UPDATE ")
					.append(tablename)
					.append(" SET ")
					.append(GLUtils.join("=?,", setKeys))
					.append("=? WHERE ")
					.append(GLJdbc.makeWhereClause(
						whereKeys, jackson.where))
					.toString();
				gl.runtimeDebugMessage("update: S is "+s);
				pst = con.prepareStatement(s);
				jackson.fillClause(pst, setKeys, sets, 0);
				jackson.fillClause(pst, whereKeys,
					jackson.where, setKeys.length);
				gl.runtimeDebugMessage("SQL is "
					+ pst.toString());
				pst.executeUpdate();
				pst.close();
				pst = null;
				if (GLJdbc.numKeys(whereKeys) <
						whereKeys.length)
					whereKeys = null;
			} while (jackson.nextRow(gl));
		}
		finally {
			if (pst != null) {
				pst.close();
				pst = null;
			}
		}
	}

	private void
	deleteUsingPostDataDeleteQuery(GLContext gl, Connection con,
		GLJdbcAction jackson, String tablename)
		throws SQLException, GLException
	{
		String[] pkey = GLUtils.hkeys(jackson.where);
		String[] whereKeys = null;
		PreparedStatement pst = null;
		try {
			do {
				if (whereKeys == null)
					whereKeys = (String[]) pkey.clone();
				String s = new StringBuffer()
					.append("DELETE FROM ")
					.append(tablename)
					.append(" WHERE ")
					.append(GLJdbc.makeWhereClause(
						whereKeys, jackson.where))
					.toString();
				gl.runtimeDebugMessage("delete: S is "+s);
				pst = con.prepareStatement(s);
				jackson.fillClause(pst, whereKeys,
					jackson.where, 0);
				gl.runtimeDebugMessage("SQL is "
					+ pst.toString());
				pst.executeUpdate();
				pst.close();
				pst = null;
				if (GLJdbc.numKeys(whereKeys) <
						whereKeys.length)
					whereKeys = null;
			} while (jackson.nextRow(gl));
		}
		finally {
			if (pst != null) {
				pst.close();
				pst = null;
			}
		}
	}

	private int
	addRecordUsingPostDataInsertQuery(GLContext gl, Connection con,
		GLJdbcAction jackson, String tablename)
		throws SQLException, GLException
	{
		findPosition(gl, jackson);
		Hashtable sets =
			jackson.getFormData(gl, gl.getRequestParameters());
		String[] setKeys = GLUtils.hkeys(sets);
		String s = new StringBuffer()
			.append("INSERT INTO ")
			.append(tablename)
			.append(" (")
			.append(GLUtils.join(",", setKeys))
			.append(") VALUES (")
			.append(GLUtils.x("?", setKeys.length, ","))
			.append(")")
			.toString();
		gl.runtimeDebugMessage("addRecord:");
		PreparedStatement pst = con.prepareStatement(s);
		int nrows = 0;
		try {
			jackson.fillClause(pst, setKeys, sets, 0);
			if (gl.runtimeDebug)
				echoSQL(gl, s, setKeys, sets);
			nrows = pst.executeUpdate();
		}
		catch (SQLException e) {
			gl.runtimeDebugMessage(e.getMessage());
			throw e;
		}
		finally {
			if (pst != null) {
				pst.close();
				pst = null;
			}
		}
		if (gl.runtimeDebug)
			gl.runtimeDebugMessage("addRecord: updated "
				+ nrows + " row(s).");
		return nrows;
	}

	/*
	 * -- Subroutines.
	 */

	private static void
	echoSQL(GLContext gl, String s, String[] setKeys, Hashtable sets)
	{
		gl.runtimeDebugMessage("<pre><b>Query</b> "+s);
		for (int i = 0; i < setKeys.length; ++i) {
			String val = GLNull.nonnull(
				sets.get(setKeys[i]))
				.toString();
			gl.runtimeDebugMessage(
				new StringBuffer("\t")
					.append("<b>")
					.append(setKeys[i])
					.append("</b> ")
					.append(val)
					.toString());
		}
		gl.runtimeDebugMessage("</pre>");
	}

	private static void
	findPosition(GLContext gl, GLJdbcAction jackson)
		throws GLException
	{
		String s = (String) gl.getRequestParameters().get("$position");
		if (s==null)
			return;
		String cle = "["+s+"]";
		do {
			if (cle.equals(jackson.getRowName()))
				return;
		} while (jackson.nextRow(gl));
		throw new GLException("Could not find $position "+s);
	}

	private static String
	getNamedURL(GLContext gl, String action, String flag) {
		return gl.getRequest().getParameter(
			GLUtils.actionParam(action, flag));
	}

	private static void
	quack1(GLContext gl, String name, ContentSourceWrapper csf) {
		if (gl.runtimeDebug)
			gl.runtimeDebugMessage(
				new StringBuffer(name)
					.append(" specified ")
					.append(csf.LastRecordOnPage()
						-csf.FirstRecordOnPage()+1)
					.append(" records (must be 1).")
					.toString());
	}

	private static void
	redirect(GLContext gl, String uri, Hashtable query, boolean ok)
		throws IOException, GLException
	{
		gl.redirect(uri, query, ok);
	}

	private static Hashtable
	resetRecordNavigation(Hashtable query, GLContext gl) {
		Hashtable a = null==query ? new Hashtable()
			: (Hashtable) query.clone();
		a.remove("RECORD_KEY");
		a.remove(xk(gl));
		a.remove("RECORD_INDEX");
		a.remove(xx(gl));
		return a;
	}

	private static String
	xk(GLContext gl) {
		String cname = gl.getRequest().getParameter("$cswName");
		return "RECORD_KEY[" + cname + "]";
	}
	private static String
	xx(GLContext gl) {
		String cname = gl.getRequest().getParameter("$cswName");
		return "RECORD_INDEX[" + cname + "]";
	}
 %>
