<%--
   - GoLive
   - Manual test page for database queries.
   -
   - ADOBE SYSTEMS INCORPORATED
   - Copyright 2000-2002 Adobe Systems Incorporated. All Rights Reserved.
   - 
   - NOTICE:  Notwithstanding the terms of the Adobe GoLive End User 
   - License Agreement, Adobe permits you to reproduce and distribute this 
   - file only as an integrated part of a web site created with Adobe 
   - GoLive software and only for the purpose of enabling your client to 
   - display their web site. All other terms of the Adobe license 
   - agreement remain in effect.
  --%>
<%@page
	import="java.io.*,java.net.*,java.sql.*,java.util.*"
	errorPage="/config/actions/error.jsp"
 %><%@page import="com.adobe.gl.runtime6.utils.*"
 %><%@page import="com.adobe.gl.runtime6.jdbc.*"
 %><%@taglib uri="/gl-taglib" prefix="gl"
 %>
<gl:page id='gl'>
<%
	gl.rejectUnauthorizedCallers();
	String title = null;
	String vsql = request.getParameter("sql[1]");
	String vsrc = request.getParameter("src[1]");
	CSWResultSet csw = null;
	CSWError cse = CSWError.newError(gl, "");
	String errortext = null;
	String []datasources = null;
	String pageColor = "#cfc";
	if (!empty(vsrc) && !empty(vsql)) {
		try {
			csw = CSWResultSet.wrapJDBCResultSet(gl, vsrc, vsql,
				"all", "");
			title = "Results";
		}
		catch (Throwable ex) {
			SQLException e = gl.exception instanceof SQLException
				? (SQLException) gl.exception : null;
			title = "Query error";
			StringBuffer ts = new StringBuffer();
			for (; e != null; e = e.getNextException()) {
				ts.append("Message: ")
					.append(e.getMessage()).append("\r\n")
					.append("SQL State: ")
					.append(e.getSQLState()).append("\r\n")
					.append("Vendor code: ")
					.append(e.getErrorCode()).append("\r\n")
					.append("\r\n");
			}
			ts.append("\r\ngl.exception is:\r\n")
				.append(gl.exception.toString());
			errortext = ts.toString();
			pageColor = "#fcc";
		}
	}
	else {
		datasources = GLJdbc.getDataSources(gl, false);
		title = "Enter an SQL query.";
	}
 %>
<html><head>
<title><%=title%></title>
<link rel="stylesheet" href="gl.css" type="text/css">
</head><body>
<h2><%=title%></h2>
<%
	if (empty(vsrc) || empty(vsql)) {
		if (!empty(vsrc)) {
			cse.SetError("sql", "!!!Empty query!!!");
			gl.storeError(cse);
		}
 %>
<form>
<table><tr><td>
Database name:
</td><td>
<select name="src[1]">
<%
		for (int i = 0; i < datasources.length; ++i) {
			String db = datasources[i];
 %>
<option label='<%=db%>' value='<%=db%>'><%=db%></option>
<%
		}
 %>
</select>
</td></tr><tr><td>
<span <%=gl.showError(cse.Error("sql"))%>>
Query text:
</span>
</td><td>
<textarea rows="5" cols="60" name="sql[1]" wrap="none"><%=cse.Error("sql")%></textarea>
</td></tr><tr><td></td><td>
<input type="submit" name="submit" value="Submit">
<input type="reset" name="rest" value="Clear form">
</td></tr></table>
</form>
<hr>
<p>
If the "Database name" pulldown contains no items,
or you are not sure of a table or field name,
please check the
<a href="troubleshooting.jsp">Adobe GoLive (JSP) Troubleshooting Report</a>.
</p>
<%
	}
	else if (errortext != null) {
 %>
<p>
Source: <%=vsrc%><br>
SQL: <%=vsql%><br>
<p>
The database server encountered an error while trying to process
your query.
Possible reasons for this are:
<ul>
<li>Misspelled or incorrect table name (some database servers,
such as MySQL,
are case-sensitive with table names).
<li>Syntactical error in the SQL.
</ul>
The actual error messages the database server returned are<br>
<pre>
<%=errortext%>
</pre>
<p>
<form>
<input type="submit" value="New query">
</form>
<%
	}
	else if (csw == null) {
 %>
<h3>
Empty results?
</h3>
<p>
<form>
<input type="submit" value="New query">
</form>
<%
	}
	else {
 %>
Source: <%=vsrc%><br>
SQL: <%=vsql%><br>
<h3>
<%=csw.RecordCount()%> <%=csw.RecordCount()==1 ? "row" : "rows"%>,
<%=csw.getColumnCount()%> <%=csw.getColumnCount()==1 ? "column" : "columns"%>.
Records <%=csw.FirstRecordOnPage()%> through <%=csw.LastRecordOnPage()%>
(<%=csw.BlockSize()%>).
</h3>
<table border="1">
<tr>
<th>#</th>
<%
		for (int j = 1; j <= csw.getColumnCount(); ++j) {
 %>
<th><%=csw.getColumnName(j)%></th>
<%
		}
 %>
</tr>
<%
		for (csw.MoveTo(1); !csw.EOB(); csw.Move(1)) {
 %>
<tr>
<th><%=csw.AbsolutePosition()%></th>
<%
			for (int j = 1; j <= csw.getColumnCount(); ++j) {
 %>
<td class="results"><%=GLFilters.htmlEncode(gl, csw.Value(j))%></td>
<%
			}
 %>
</tr>
<%
		}
 %>
</table>
<p>
<form>
<input type="submit" value="New query">
</form>
<%
	}
 %>
<%@include file="/WEB-INF/jspi/footer.jspi"%>
</body></html>
</gl:page>
<%!
	private static boolean
	empty(String s) {
		return s==null || "".equals(s);
	}
 %>
