<%--
   - GoLive
   - Diagnostics for the server-side authoring environment.
   -
   - ADOBE SYSTEMS INCORPORATED
   - Copyright 2000-2002 Adobe Systems Incorporated. All Rights Reserved.
   - 
   - NOTICE:  Notwithstanding the terms of the Adobe GoLive End User 
   - License Agreement, Adobe permits you to reproduce and distribute this 
   - file only as an integrated part of a web site created with Adobe 
   - GoLive software and only for the purpose of enabling your client to 
   - display their web site. All other terms of the Adobe license 
   - agreement remain in effect.
  --%>
<%@page
	import="java.io.*,java.lang.*,java.net.*,java.util.*,java.sql.*"
	errorPage="/config/actions/error.jsp"
 %><%@page import="com.adobe.gl.runtime6.utils.*"
 %><%@page import="com.adobe.gl.runtime6.jdbc.*"
 %><%@page import="com.adobe.gl.runtime6.xml.*"
 %><%@page import="com.adobe.gl.runtime6.custommerchant.*"
 %><%@page import="org.apache.regexp.*"
 %><%@page import="org.w3c.dom.*"
 %><%@page contentType="text/html;charset=utf-8"
 %><%@taglib uri="/gl-taglib" prefix="gl"
 %>
<%@include file="troubleshootinginclude.jsp"%>
 <%!
	private Test[]
	runTests(GLContext gl) {
		Vector v = new Vector();
		v.add(checkServerVersion(gl));
		v.add(checkServerClasses(gl));
		v.add(checkServerConfigFiles(gl));
		v.add(checkServerConfigFriendsFile(gl));
		v.add(checkWriteFile(gl));
		v.add(checkDBs(gl));
		v.add(checkECPs(gl));
		v.add(checkXDSes(gl));
		Test[] t = new Test[v.size()];
		v.copyInto(t);
		return t;
	}
	/*
	 * -- Tests
	 */
	private Test
	checkDBs(GLContext gl) {
		boolean confail = false;
		Test test = new Test("Check JDBC datasources");
		test.description =
			"This test shows you what this web app"
			+ " thinks the available datasources are,"
			+ " along with some information about the tables.";
		String[] names = GLJdbc.getDataSources(gl, false);
		int ngood = names.length;
		test.details.append(TABLE_STARTTAG)
			.append("\r\n<tr>\r\n")
			.append("<th>name</th><th>driver/dburl")
			.append("<th>conn?</th><th>info</th>")
			;
		for (int i = 0; i < names.length; ++i) {
			Hashtable a = getDBparams(gl, names[i]);
			String s = testConn(gl, names[i]);
			test.details.append("</tr>\r\n<tr>")
				.append("<td class='jdbc'>")
				.append(s!=null ? ""
					: "<a href='#d_"+names[i]+"'>")
				.append(names[i])
				.append(s!=null ? "" : "</a>")
				.append("</td><td class='jdbc'>")
				.append(a.get("driver"))
				.append("<br>").append(a.get("dburl"))
				.append("</td><td class='jdbc'>")
				.append(s==null ? "OK" : s)
				.append("</td><td class='jdbc'>")
				.append(driverInfo((String) a.get("dburl")))
				;
			if (s != null) {
				confail = true;
				names[i] = null;
				--ngood;
			}
		}
		test.details.append("</tr></table>\r\n");
		if (names.length==0)
			test.details.append("<span class='rien'>")
				.append("No datasources were detected.")
				.append("</span>\r\n");
		else if (ngood == 0)
			test.details.append("<span class='failed'>")
				.append("No datasources are accessible.")
				.append("</span>\r\n");
		else {
			test.details.append(
				"<h4>Table details (by database):</h4>");
			for (int i = 0; i < names.length; ++i) {
				if (names[i]==null)
					continue;
				/* <a name='d_databasename'><table> ... */
				test.details.append("<a name='d_")
					.append(names[i])
					.append("'></a>");
				test.details.append(TABLE_STARTTAG)
					.append("<tr><th>")
					.append(names[i])
					;
				test.details.append("</tr><tr>\r\n")
					.append("<td class='jdbc'>\r\n");
				showTables(test.details, gl, names[i]);
				test.details.append("</tr></table><p>\r\n");
			}
		}
		if (confail)
			test.fail("Couldn't connect to 1 or more datasources.");
		else
			test.verify(
				"Make sure this list is complete and correct.");
		return test;
	}

	private Test
	checkECPs(GLContext gl) {
		Test test = new Test("Check CustomMerchant datasources");
		test.description =
			"This test shows you what this web app"
			+ " thinks the available CustomMerchant datasources are.";

		int counterEcp = 0;
		int error = 0;
		String errStr = "<span class=\"failed\">ERROR</span><br>\n";
		RE re = null;
		try {
			re = new RE("\\s+");
		}
		catch (RESyntaxException e) {
			test.details.append("Exception " + e.toString()).
				append("<br>\r\n*Pattern failure*<br>\r\n");
		}

		String[] names = CMUtils.getDataSources(gl, false);
		test.details.append(TABLE_STARTTAG)
			.append("\r\n<tr>\r\n")
			.append("<th>name</th><th>setting</th>\r\n");
		for (int i = 0; i < names.length; ++i) {
			test.details.append("</tr><tr>\r\n").append("<td>")
				.append(names[i]).append("</td>\r\n<td>");
			File file = CMUtils.getDataSourceFile(gl, names[i]);
			LineNumberReader lnr = null;
			int lineNumber = 0;
			int errorOnFile = 0;
			try {
				lnr = new LineNumberReader(new FileReader(file));
				counterEcp++;
				String line = null;
				int counterUrl = 0;
				int counterMID = 0;
				while ((line = lnr.readLine()) != null) {
					String[] lineContent = re.split(line.trim());
					if (lineContent.length < 2)
						continue;

					String param = lineContent[0];
					String value = lineContent[1];
					if ("url".equals(param)) {
						counterUrl++;
						test.details
							.append("url: <a target=\"_blank\" href=\"")
							.append(value).append("\">")
							.append(value).append("</a><br>\r\n");
						if (value == "") {
							test.details.append(errStr)
							.append("\"url\" value is not set.<br>\r\n");
							error++;
						} else {
							test.details
							.append("<span class=\"verify\">Verify ")
							.append("the URL</span><br>\r\n");
						}
					}
					else if ("merchant-id".equals(param)) {
						counterMID++;
						test.details.append("merchant-id: ")
							.append(value).append("<br>\r\n");
						if (value == "") {
							test.details.append(errStr)
							.append("\"merchant-id\" value is not set.<br>\r\n");
							error++;
						}
					}
				}

				if (counterUrl == 0) {
					test.details.append(errStr)
						.append("\"url\" setting is not in the file.<br>\r\n");
					error++;
				}
				if (counterUrl > 1) {
					test.details.append(errStr)
						.append("There are multiple \"url\" settings in ")
						.append("the file.<br>\r\n");
					error++;
				}
				if (counterMID == 0) {
					test.details.append(errStr)
						.append("\"merchant-id\" setting is not in ")
						.append("the file.<br>\r\n");
					error++;
				}
				if (counterMID > 1) {
					test.details.append(errStr)
						.append("There are multiple \"merchant-id\" ")
						.append("settings in the file.<br>\r\n");
					error++;
				}
				test.details.append("</td>\r\n");
			}
			catch (IOException e) {
				test.details.append(e.toString());
			}
			finally {
				try { lnr.close(); } catch (Exception e) {}
			}
		}
		test.details.append("</tr>\r\n</table>\r\n");

		if (names.length==0) {
			test.details.append("<span class='rien'>")
				.append("No datasources were detected.")
				.append("</span>\r\n");
		}
		if (error != 0) {
			test.fail("Problem(s) were found with one or more datasource file(s).");
		} else {
			if (counterEcp == 0) {
				test.verify("No CustomMerchant datasource file (*.ecp) found in datasources folder.");
			} else {
				test.verify("Verify url setting on the each hyperlink.");
			}
		}
		return test;
	}

	private Test
	checkXDSes(GLContext gl) {
		Test test = new Test("Check XML datasources");
		test.description =
			"This test shows you what this web app"
			+ " thinks the available XML datasources are.";

		int counterXds = 0;
		int error = 0;
		String errStr = "<span class=\"failed\">ERROR</span><br>\n";
		RE re = null;;
		try {
			re = new RE("\\s");
		}
		catch (RESyntaxException e) {
			test.details.append("Exception " + e.toString()).
				append("<br>\r\n*Pattern failure*<br>\r\n");
		}

		String[] names = CSWXML.getDataSources(gl, false);
		test.details.append(TABLE_STARTTAG)
			.append("\r\n<tr>\r\n")
			.append("<th>name</th><th>setting</th>\r\n");
		for (int i = 0; i < names.length; ++i) {
			test.details.append("</tr><tr>\r\n").append("<td>")
				.append(names[i]).append("</td>\r\n<td>");
			File file = CSWXML.getDataSourceFile(gl, names[i]);
			int errorOnFile = 0;
			try {
				counterXds++;
				Document doc = null;
				try {
					doc = GLXML.asDom(gl, file);
				} catch (GLException e) {
					errorOnFile++;
					test.details.append(errStr)
						.append(e.toString());
				}
				if (errorOnFile != 0) {
					error++;
				} else {
					test.details.append("XML format is fine.");
					
				}
				test.details.append("</td>\r\n");
			} catch (IOException e) {
				test.details.append(e.toString());
			}
		}
		test.details.append("</tr>\r\n</table>\r\n");

		if (names.length==0) {
			test.details.append("<span class='rien'>")
				.append("No datasources were detected.")
				.append("</span>\r\n");
		}
		if (error != 0) {
			test.fail("Problem(s) were found with one or more datasource file(s).");
		} else {
			if (counterXds == 0) {
				test.verify("No XML datasource file (*.xds) found in datasources folder.");
			} else {
				test.pass("XML datasource(s) seem to be fine.");
			}
		}
		return test;
	}

	private Test
	checkServerClasses(GLContext gl) {
		Test test = new Test("Check server classes");
		test.description =
"This test checks to see if certain Java classes are available"
+ " to this web application."
+ " If they aren't, some pages may not work correctly.";

		String sep = 
			"The following required classes are missing:<br>\r\n";
		int nlosers = 0;
		test.details.append(TABLE_STARTTAG)
			.append("\r\n<tr><th>Name</th><th>Found?</th>")
			.append("<th>Note</th></tr>\r\n");
		for (int i = 0; i < requiredClasses.length; ++i) {
			Class c = null;
			String cname = requiredClasses[i][0];
			String scname = cname;
			boolean need = "".equals(requiredClasses[i][1]);
			String note = requiredClasses[i][2];
			String mem = null;

			int pi = cname.indexOf('#');
			if (pi >= 0) {
				mem = cname.substring(1+pi);
				cname = cname.substring(0, pi);
			}

			try {
				c = Class.forName(cname);
			}
			catch (Exception e) {}
			boolean found = c!=null
				&& (mem==null || hasMethod(c, mem));
			if (!found)
				++nlosers;

			test.details.append("<tr>")
				.append("<td>")
				.append("<code>")
				.append(c==null ? cname : scname)
				.append("</code>")
				.append("</td><td>\r\n");
			test.details.append(!found
				? "<span class='failed'>NO</span>"
				: "yes");
			test.details.append("\r\n</td><td>\r\n")
				.append(note)
				.append("</td></tr>\r\n");
		}
		test.details.append("</table>");
		if (nlosers == 0)
			test.pass("All required classes are present.");
		else {
			test.fail("Missing "+nlosers+" required classes.");
			test.details.append(
"<p>If a name like <span class='failed'>class.name#methodname</span>"
+ " is reported missing: the class itself is present, but a particular method"
+ " is missing from the its interface. Typically, this means that the wrong"
+ " version of the class is loaded.");
		}
		return test;
	}

	private Test
	checkServerConfigFiles(GLContext gl) {
		Test test = new Test("Check server config files");
		test.description =
"This test checks to see whether the JSP and XML files for GoLive"
+ " have been properly installed on the server."
+ " It also produces a directory tree listing of all files in"
+ " the config folders."
;
		String root = gl.getApplication().getRealPath("/");
		test.details.append("<p>Files are rooted in the")
			.append(" server directory <code><b>")
			.append(root).append("</b></code>")
			.append("<p>");

		test.details.append(TABLE_STARTTAG)
			.append("\r\n<tr>")
			.append("<th>Name</th><th>Found?</th><th>Note</th>")
			.append("</tr>\r\n");
		int nlosers = 0;

		for (int i = 0; i < requiredFiles.length; ++i) {
			String name = requiredFiles[i][0];
			boolean need = "".equals(requiredFiles[i][1]);
			String note = requiredFiles[i][2];

			File f = new File(root, name);
			boolean found = f.exists();
			if (!found)
				++nlosers;
			test.details.append("<tr><td>")
				.append("<code>").append(name).append("</code>")
				.append("</td>\r\n<td>")
				.append(!found
					? "<span class='failed'>NO</span>"
					: "yes")
				.append("</td>\r\n<td>").append(note)
				.append("</td></tr>\r\n");
		}
		test.details.append("</table>");
		if (nlosers == 0)
			test.pass("All required files are present.");
		else
			test.fail("Missing "+nlosers+" required files.");

		/*
		 * Construct the directory trees for WEB-INF/ and config/.
		 */
		test.details.append("<h4>")
			.append("Directory tree listing of config folders.")
			.append("</h4>\r\n<p>\r\n");
		test.details.append("<pre>\r\n");
		test.details.append("<b>").append(root)
			.append("WEB-INF {</b>\r\n");
		fscrawl(gl, test.details, new File(root, "WEB-INF"), 1);
		test.details.append("<b>}</b>\r\n");
		test.details.append("<b>").append(root)
			.append("config {</b>\r\n");
		fscrawl(gl, test.details, new File(root, "config"), 1);
		test.details.append("<b>}</b>\r\n</pre>\r\n");

		return test;
	}

	private Test
	checkServerConfigFriendsFile(GLContext gl) {
		Test test = new Test("Check /WEB-INF/friends.xml");
		test.description =
			"This test checks the /WEB-INF/friends.xml file"
			+ " which is used"
			+ " to provide IP-based security. By default, access"
			+ " to the GoLive files is only allowed to"
			+ " to the local host."
			+ " To allow access from another machine, you must"
			+ " edit the /WEB-INF/friends.xml file to include the"
			+ " IP address of that machine.";
		String h = "", h2 = "";
		StringBuffer shja = new StringBuffer();
		int checker = 0;
		String[][] friends = null;
		try {
			friends = gl.getFriends();
		}
		catch (Exception e) {
			friends = new String[0][];
			shja.append("Exception " + e.toString()
				+ " caught reading friends file.");
			checker = 4;
		}
		shja.append(TABLE_STARTTAG);
		shja.append("\r\n<tr><th>IP address<th>Mask<th>Note</tr>\r\n");
		for (int i = 0; i < friends.length; ++i) {
			h = friends[i][0].trim();
			h2 = friends[i].length < 2 ? "255.255.255.255"
				: friends[i][1].trim();
			shja.append("<tr><td>").append(h)
				.append("<td>").append(h2)
				.append("<td>");
			try {
				if ("127.0.0.1".equals(h)
				 && "255.255.255.255".equals(h2))
				{
					shja.append(
						"This is the default setting.");
					if (checker < 4)
						checker = 1;
				}
				else if ("0.0.0.0".equals(h2)) {
					shja.append(
						"This setting disables "
						+ "all security.");
					if (checker < 4)
						checker = 3;
				}
				else {
					shja.append("Nonstandard setting.");
					if (checker < 4)
						checker = 2;
				}
			}
			catch (Exception e) {
				checker = 4;	/* format error */
				shja.append("Invalid setting.");
			}
			shja.append("</tr>\r\n");
		}
		shja.append("</table>\r\n");
		switch (checker) {
		case 0:
			test.fail("No IP addresses found in friends file");
			break;
		case 1:
			test.pass("The friends file uses the default setting. "
				+ "Access is limited to the local host.");
			break;
		case 2:
			test.pass("Nonstandard friends configuration.");
			break;
		case 3:
			test.verify("The friends file is set as "
				+ "``disable all security''.");
			break;
		default:
			test.fail("Format error in friends file");
			break;
		}
		test.details = shja;
		return test;
	}

	private Test
	checkServerVersion(GLContext gl) {
		Test test = new Test("Check server version");
		test.description =
			"Here is a list of interesting server parameters "
			+ "that may be helpful for debugging.";
		HttpServletRequest req = gl.getRequest();

		test.pass("Server settings retrieved.");
		test.details.append(TABLE_STARTTAG).append("<tr>\r\n");
		test.details.append("<th>webapp");
		test.details.append("<td>")
			.append(req.getContextPath());
		test.details.append("</tr>\r\n<tr>");
		test.details.append("<th>Server");
		test.details.append("<td>")
			.append(req.getServerName());
		test.details.append("</tr>\r\n<tr>");
		test.details.append("<th>JSP Container");
		test.details.append("<td>")
			.append(getJSPContainerVersion(gl));

		test.details.append("</tr>\r\n<tr>");
		test.details.append("<th>Init Parameters");
		test.details.append("<td>");
		{
			ServletContext appl = gl.getApplication();
			String[] a = getinitparams(appl);
			String ow = "";
			for (int i = 0; i < a.length; ++i)
				test.details
					.append(ow.equals(ow=firstWord(a[i]))
						? "" : "<br>")
					.append("<span class='propname'>")
					.append(a[i]).append("</span> ")
					.append(appl.getInitParameter(a[i]))
					.append("<br>\r\n");
			if (a.length==0)
				test.details.append("<span class='rien'>")
					.append("The application has no ")
					.append("init parameters.")
					.append("</span>");
		}

		test.details.append("</tr>\r\n<tr>");
		test.details.append("<th>Application parameters");
		test.details.append("<td>");
		{
			ServletContext appl = gl.getApplication();
			String ow = "";
			for (Enumeration e = appl.getAttributeNames();
			     e.hasMoreElements();)
			{
				String name = (String) e.nextElement();
				String value =
					GLNull.nonnull(appl.getAttribute(name))
						.toString();
				test.details
					.append(ow.equals(ow=firstWord(name))
						? "" : "<br>")
					.append("<span class='propname'>")
					.append(name).append("</span> ")
					.append(bl(uc(value)))
					;
			}
		}
		test.details.append("</tr>\r\n<tr>");
		test.details.append("<th>System Properties");
		test.details.append("<td>");
		{
			String[] a = getsysprops();
			String ow = "";
			for (int i = 0; i < a.length; ++i)
				test.details
					.append(ow.equals(ow=firstWord(a[i]))
						? "" : "<br>")
					.append("<span class='propname'>")
					.append(a[i]).append("</span> ")
					.append(bl(
						uc(System.getProperty(a[i]))))
					.append("<br>\r\n");
		}

		test.details.append("</tr>\r\n</table>");
		return test;
	}

	private Test
	checkWriteFile(GLContext gl) {
		Test test = new Test("Write file on server");
		test.description =
			"This test checks that you are able to write "
			+ "files on the server. "
			+ "GoLive uses this to create temporary "
			+ "files for Preview mode.";
		File file = new File(
			gl.configFileName(GLUtils.GL_PREFIX+"ui-info.")
			+ "small$test$file.jsp");
		if (testWriteFileOnServer(file))
			test.pass("OK " + file.getAbsolutePath());
		else
			test.fail("Couldn't write " + file.getAbsolutePath());
		return test;
	}

	/*
	 * -- Subroutines.
	 */

	/**
	 * Some of the parameter values we're printing get to be very
	 * long.  Here try to do something sensible about breaking them
	 * up into readable values.  The idea is that the longest strings
	 * are ':'-separated path values, so we break the lines on them.
	 */
	private static String
	bl(String s) {
		final String PS = File.pathSeparator;
		if (s.length() < 64	/* just a guess */
		 || s.indexOf(PS) < 0)
			return s;
		return GLUtils.join(PS+"\\<br>\r\n", GLUtils.split(PS, s));
	}
	private static String
	driverInfo(String dburl) {
		String quack = "Could not find driver for ";
		try {
			java.sql.Driver d =
				java.sql.DriverManager.getDriver(dburl);
			quack = "Could not interrogate driver for ";
			return new StringBuffer()
				.append('v')
				.append(d.getMajorVersion())
				.append('.')
				.append(d.getMinorVersion())
				.append("<br>compliant=")
				.append(d.jdbcCompliant()?'Y':'N')
				.toString();
		}
		catch (Exception e) {
			return GLUtils.cat("<span class='failed'>",
				quack, dburl, "</span>");
		}
	}
	private static String
	firstWord(String s) {
		final int i = s.indexOf(".");
		return i < 0 ? s : s.substring(0, i);
	}
	/**
	 * Recursively traverse the directory tree below ROOTD, appending
	 * each item to TS.  DEPTH tracks the depth of the tree and indicates
	 * how much to indent each item.
	 * <p>
	 * We "assume" that the caller will reformat if it wants to; this
	 * code just uses '\r\n' for line separators.
	 */
	private static void
	fscrawl(GLContext gl, StringBuffer ts, File rootd, int depth) {
		String[] files = rootd.list();
		if (files==null)
			return;
		Arrays.sort(files);
		for (int i = 0; i < files.length; ++i) {
			File f = new File(rootd, files[i]);
			indent(ts, depth);
			if (f.isDirectory()) {
				ts.append("<b>").append(files[i])
					.append(" { </b>\r\n");
				fscrawl(gl, ts, f, 1+depth);
				indent(ts, depth);
				ts.append("<b>}</b>\r\n");
			}
			else
				ts.append(files[i]).append("\r\n");
		}
	}
	private static Hashtable
	getDBparams(GLContext gl, String database) {
		try {
			return gl.getParams(GLUtils.GL_PREFIX + "datasources."
				+ database);
		}
		catch (Exception e) {
			return new Hashtable();
		}
	}
	private static String
	getJSPContainerVersion(GLContext gl) {
		return new StringBuffer()
			.append(gl.getApplication().getServerInfo())
			.append(" ")
			.append(gl.getApplication().getMajorVersion())
			.append(".")
			.append(gl.getApplication().getMinorVersion())
			.append("; JSP Specification ")
			.append(JspFactory
				.getDefaultFactory()
				.getEngineInfo()
				.getSpecificationVersion())
			.toString()
			;
	}
	private static String[]
	getsysprops() {
		Vector v = new Vector();
		for (Enumeration e = System.getProperties().propertyNames();
		     e.hasMoreElements();)
		{
			v.add(e.nextElement());
		}
		String[] a = new String[v.size()];
		v.copyInto(a);
		Arrays.sort(a);	/* java.util.Arrays is a Java 2 feature */
		return a;
	}
	private static String[]
	getinitparams(ServletContext appl) {
		Vector v = new Vector();
		for (Enumeration e = appl.getInitParameterNames();
		     e.hasMoreElements();)
		{
			v.add(e.nextElement());
		}
		String[] a = new String[v.size()];
		v.copyInto(a);
		Arrays.sort(a);	/* java.util.Arrays is a Java 2 feature */
		return a;
	}

	private static boolean
	hasMethod(Class c, String mname) {
		java.lang.reflect.Method[] methods = c.getMethods();
		for (int i = 0; i < methods.length; i++) {
			if (methods[i].getName().equals(mname))
				return true;
		}
		return false;
	}

	static private void
	indent(StringBuffer ts, int depth) {
		while (--depth >= 0)
			ts.append("    ");
	}

	/**
	 * Format into TS info on the table named by TABLE.
	 */
	private static void
	showTable(StringBuffer ts, GLContext gl, Connection con,
		String table, String db)
	{
		Statement st = null;
		ResultSet rs = null;
		try {
			/*
			 * Discover the table's primary keys, if any.
			 */
			DatabaseMetaData dbmd = con.getMetaData();
			/*
			 * bug: Oracle insists, and Postgres doesn't mind,
			 * that we coerce the table name to uppercase.
			 * But MySQL objects strenuously.
			 */
			rs = dbmd.getPrimaryKeys(null, null,
				table/*.toUpperCase()*/);
			ts.append("<h2>Table: ").append(table).append("</h2>");
			int k = ts.length();
			ts.append("<span class='passed'>Primary keys: ")
				.append("</span>\r\n");
			String sep = "";
			while (rs.next()) {
				/*
				 * bug: Oracle returns keys from other
				 * datasources, e.g., you ask for MAGAZINE,
				 * it returns items for both MAGAZINE and
				 * MAGAZINE_J1.
				 */
				final String schema = rs.getString(2);
				if (schema != null && !"".equals(schema)
				 && !db.equalsIgnoreCase(schema))
					continue;
				ts.append(sep).append(rs.getObject(4));
				sep = ", ";
			}
			if (sep.length()==0) {
				ts.setLength(k);
				ts.append("\r\n<span class='verify'>")
					.append("No primary keys were found.")
					.append("</span>\r\n");
			}
			rs.close();

			/*
			 * Extract column names and types.
			 */
			ts.append(TABLE_STARTTAG);
			ts.append("\r\n<tr><th>Name</th><th>Type</th>")
				.append("<th>Precision/Scale</th>")
				.append("\r\n");
			st = con.createStatement();
			rs = st.executeQuery("select * from "+table);
			ResultSetMetaData mdata = rs.getMetaData();
			int ncol = mdata.getColumnCount();
			for (int j = 1; j <= ncol; ++j) {
				ts.append("\r\n</tr><tr>");
				try {
					ts.append("\r\n<td class='jdbc'>")
						.append(mdata.getColumnName(j));
					ts.append("\r\n</td><td class='jdbc'>(")
						.append(mdata.getColumnType(j))
						.append(") ")
						.append(mdata
							.getColumnTypeName(j))
						;
					ts.append("\r\n</td><td class='jdbc'>")
						.append(mdata.getPrecision(j))
						.append('/')
						.append(mdata.getScale(j))
						;
				} catch (Exception e) {
					ts.append("<td>").append(e.toString());
				}
			}
		}
		catch (Exception e) {
			ts.append("<td class='jdbc'>").append(e.toString());
		}
		finally {
			try { rs.close(); } catch (Exception e) {}
		}
		ts.append("\r\n</tr></table>\r\n");
	}

	/**
	 * Format info into TS on all the tables in the database named
	 * by DB.
	 */
	private static void
	showTables(StringBuffer ts, GLContext gl, String db) {
		Connection con = null;
		DatabaseMetaData dbmd = null;
		ResultSet rs = null;
		try {
			con = GLJdbc.getConnection(gl, db);
			dbmd = con.getMetaData();
			rs = dbmd.getTables(null, null, "%", null);
			Vector v = new Vector();
			String sep = "Tables: ";
			final String[] typematch = {
				"TABLE", "VIEW"
			};
			final String[] badSchemas = {
				"SYS", "SYSTEM"
			};
			/*
			 * Tables: <a href='#tb_tablename'>tablename</a>, ...
			 */
			while (rs.next()) {
				String ttype = rs.getString(4),
					tschema = rs.getString(2);
				if (!empty(ttype)
					 && !GLUtils.any(typematch, ttype)
				 || !empty(tschema)
					 && GLUtils.any(badSchemas, tschema))
					continue;
				if (!empty(tschema)
				 && !tschema.equalsIgnoreCase(db))
					continue;
				String tname = rs.getString(3);
				v.add(tname);
				ts.append(sep)
					.append("<a href='#tb_")
					.append(tname)
					.append("'>").append(tname)
					.append("</a>")
					;
				ts.append("<!--")
					.append(" schema ")
					.append(rs.getString(2))
					.append(" type ")
					.append(rs.getString(4))
					.append("-->\r\n");
				sep = ", ";
			}
			/*
			 * <a name='tb_tablename'></a><table>...
			 * ...
			 */
			for (int i = 0; i < v.size(); ++i) {
				String tname = (String) v.get(i);
				ts.append("<a name='tb_").append(tname)
					.append("'></a>\r\n");
				showTable(ts, gl, con, tname, db);
			}
		}
		catch (Exception e) {
			gl.getApplication().log("", e);
			ts.append(e.toString());
		}
		finally {
			try { rs.close(); } catch (Exception e) {}
			try { con.close(); } catch (Exception e) {}
		}
	}

	private static String
	testConn(GLContext gl, String ds) {
		try {
			GLJdbc.getConnection(gl, ds).close();
			return null;
		}
		catch (Throwable e) {
			return e.toString();
		}
	}
	private static boolean
	testWriteFileOnServer(File file) {
		FileOutputStream fso = null;
		boolean ok = false;
		try {
			fso = new FileOutputStream(file);
			fso.write("GoLive Dynamic Content\r\n".getBytes());
			fso.close();
			ok = file.delete();
		}
		catch (Exception e) {
		}
		return ok;
	}

	/**
	 * Convert control characters into printable ^c sequences.
	 */
	private static String
	uc(String s) {
		final int N = s.length();
		for (int i = 0;; ++i) {
			if (i == N)
				return s;
			else if (s.charAt(i) < ' ')
				break;
		}
		StringBuffer ts = new StringBuffer();
		for (int i = 0; i < N; ++i) {
			final char c = s.charAt(i);
			if (c >= ' ')
				ts.append(c);
			else
				ts.append('^')
					.append((char) ((int)c+(int)'A'-1));
		}
		return ts.toString();
	}

	/**
	 * List of classes that we "know" we need.
	 */
	private static final String[][] requiredClasses = {
		new String[] { "javax.sql.DataSource", "",
			"Interface to JDBC data sources",
		},
		new String[] { "org.apache.xpath.XPathAPI", "",
			"XSLT component",
		},
		new String[] { "org.w3c.dom.Node#isSupported", "",
			"Demonstrates that the XML DOM code is at Level 2"
			+ " or higher."
			+ " Required for XML content sources and eCommerce.",
		},
		new String[] { "java.security.Security", "",
			"Enables HTTPS outcalls.  Required for eCommerce."
		},
		new String[] { "com.sun.net.ssl.internal.ssl.Provider", "",
			"Enables HTTPS outcalls.  Required for eCommerce."
		},
//		new String[] {
//			"javax.servlet.http.HttpServletRequest"
//				+ "#setCharacterEncoding",
//			"",
//			"Automatically handle non-Unicode character sets"
//				+ " in form input",
//		},
	};

	/**
	 * List of files that we "know" we need.
	 */
	private static final String[][] requiredFiles = {
		new String[] { "WEB-INF/friends.xml", "",
			"Data for IP-based security",
		},
		new String[] { "WEB-INF/jspi/footer.jspi", "",
			"Standard footer for config/ pages",
		},
		new String[] { "WEB-INF/lib/jakarta-regexp-1.2.jar", "",
			"Runtime support for regular expressions",
		},
//	mysql.jar check needs manual installation.
//		new String[] { "WEB-INF/lib/mysql.jar", "jdbc",
//			"Driver for the MySQL database",
//		},
//		new String[] { "WEB-INF/lib/xerces.jar", "",
//			"XML parser"
//		},
		new String[] { "WEB-INF/web.xml", "",
			"Required by JSP container",
		},
		new String[] { "config/actions/error.jsp", "",
			"Error page for JSP exceptions",
		},
		new String[] { "config/actions/glerror.jsp", "",
			"Error page for user/database errors",
		},
		new String[] { "config/datasources", "",
			"Directory contains descriptions of data sources",
		},
		new String[] { "config/actions/jdbc.actions6.jsp", "",
			"Performs standard form actions on JDBC databases",
		},
		new String[] { "config/info/general.ui6.xml", "",
			"supports UI queries from GoLive",
		},
		new String[] { "config/info/jdbc.info6.jsp", "",
			"Describes database (JDBC) content sources to GoLive",
		},
		new String[] { "config/info/jdbc.ui6.xml", "",
			"supports UI queries from GoLive",
		},
		new String[] { "config/info/parsejsp.jsp", "",
			"supports Preview mode from GoLive",
		},
		new String[] { "config/info/test.html", "",
			"GoLive checks for this file when verifying the site",
		},
		new String[] { "config/info/testsql.jsp", "",
			"supports manual testing of database queries",
		},
		new String[] { "config/info/ui6.jsp", "",
			"UI queries from GoLive",
		},
	};
	private static final String TABLE_STARTTAG =
		"<table border=\"1\" cellpadding=\"4\">";
	private static final String TITLE =
		"Adobe GoLive (JSP) Troubleshooting Report";
	private static final int WHICHPAGE = TSHOOT;
 %>
