<?php
$GLparam = array(
	/*
	 * Arrange to send data in the UTF-8 charset.
	 */
	'output_encoding'=>'UTF-8',
	'content_type'=>'text/html',
);
require_once("../include/utils.runtime6.php");
require_once("../include/mysql.runtime6.php");

/*
 * GoLive
 * Let user run sample queries against a MySQL database.
 * If the variables $src and $sql are not set, run a form that lets the
 * user offer a query.  Otherwise, run the query and present the results.
 *
 * ADOBE SYSTEMS INCORPORATED
 * Copyright 2000-2002 Adobe Systems Incorporated. All Rights Reserved.
 * 
 * NOTICE:  Notwithstanding the terms of the Adobe GoLive End User 
 * License Agreement, Adobe permits you to reproduce and distribute this 
 * file only as an integrated part of a web site created with Adobe 
 * GoLive software and only for the purpose of enabling your client to 
 * display their web site. All other terms of the Adobe license 
 * agreement remain in effect.
 */

/*
 * Called from the form page to populate the popup of data source names.
 * If we write one of these per database type, then the form page can remain
 * unchanged -- doesn't need to know about the database particulars.
 *
 */
function dsnames() {
	$handle = opendir(GetDataSourcePath());
	$ds = array();
	while ($file = readdir($handle)) {
		if(ereg("(.*)\.mysql\.sbs", $file, $regs)){
		$ds[] = $regs[1];
		}
	}
	return $ds;
}

RejectUnauthorizedCallers();

$title = null;
$error = "";

/*
 * The interface to the form page is particularly simple: just pass
 * the page title as $title.
 * The interface to the results page is almost as simple: just pass
 * the content source wrapper as $tcsw along with $title.
 * The interface to the error page sends along $title and $error.
 */
if (!isset($src) && !isset($sql)) {
	$title = "MySQL query test";
	include("testsql_form.inc");
}
else if ($tcsw = WrapMySQLDatabaseResults($src, $sql, "block=100000", 'tcsw')) {
	$title = "MySQL query results.";
	include("testsql_results.inc");
}
else {
	$title = "MySQL error results.";
	$error = mysql_errno() . ' ' . mysql_error();
	include("testsql_error.inc");
}

?>
